
#include <stdio.h>

#include "windows.h"

#include "peexe.h"

#include "thread.h"
#include "Segment.h"
#include "bin32.h"

#include "Log.h"
#include "ctype.h"

#include "setjmp.h"
#include "LoadPE.h"
#include "BinTypes.h"
#include "Resources.h"
#include "Module.h"
#include "Endian.h"
#include "Strings32.h"
#include "lib32.h"

extern int LoadBin32MenuA(HINSTANCE hInstance, LPCSTR , HMENU *);
extern void CleanupDialog(LPBYTE);
HMODULE GetModuleFromInstance(HINSTANCE);	

HMENU   TWIN_LoadMenu32(HINSTANCE , LPCTSTR ,int );
HICON   TWIN_LoadIcon32(HINSTANCE , LPCSTR ,int );
int     TWIN_LoadString32(HINSTANCE , UINT ,LPSTR ,int ,int );
HCURSOR TWIN_LoadCursor32(HINSTANCE , LPCSTR ,int );
HACCEL	TWIN_LoadAccelerators32(HINSTANCE , LPCSTR , int );

TWINRT DefaultTwinRT32 = {
	TWIN_LoadMenu32,
	TWIN_LoadIcon32,
	TWIN_LoadString32,
	TWIN_LoadCursor32,
	0,
	TWIN_LoadAccelerators32,
	0,
	0,
	0,
	0,
	0,	
	0,
	0,
};

#if 0
	HMENU   (*lpfmenu)(HINSTANCE , LPCSTR ,int);
	HICON   (*lpficon)(HINSTANCE , LPCSTR ,int);
	int     (*lpfstring)(HINSTANCE , UINT, LPSTR, int, int );
	HCURSOR (*lpfcursor)(HINSTANCE , LPCSTR ,int);
	HBITMAP (*lpfbitmap)(HINSTANCE , LPCSTR ,int);
	HACCEL  (*lpfaccel)(HINSTANCE , LPCSTR ,int);
	BOOL    (*lpffree)(HGLOBAL );
	HRSRC   (*lpffind)(HINSTANCE ,LPCSTR ,LPCSTR );
	HGLOBAL (*lpfload)(HINSTANCE , HRSRC );
	DWORD   (*lpfsizeof)(HINSTANCE , HRSRC );
	HWND    (*lpfcreatedlg)(HINSTANCE ,LPCSTR ,HWND ,DLGPROC ,LPARAM ,int);
	int     (*lpfdialogbox)(HINSTANCE ,LPCWSTR ,HWND ,DLGPROC ,LPARAM ,int);
	FARPROC (*lpfgetprocaddr)(HINSTANCE,LPCSTR,int);
#endif

PIMAGE_RESOURCE_DIRECTORY
FindResourceDirectory( MODULE_HEADERS *lpNTModule,
	PIMAGE_RESOURCE_DIRECTORY root,
	PIMAGE_RESOURCE_DIRECTORY resdir, DWORD wID,UINT uiFlags)
{
	PIMAGE_RESOURCE_DIRECTORY       subdir = 0;
	PIMAGE_RESOURCE_DIRECTORY_ENTRY et;
	int i;
	int entries,namelen;
	short szResourceName[256];
	LPWSTR lpwstr;
	

	et = MAKEPTR((PIMAGE_RESOURCE_DIRECTORY_ENTRY),
		resdir,sizeof(IMAGE_RESOURCE_DIRECTORY));

		
	if (HIWORD(wID)) {
	   if(uiFlags == 1) {
		lstrcpyAtoW( (LPWSTR) szResourceName, (LPCSTR) wID );
		lpwstr = szResourceName;
	   } else
		lpwstr = (LPWSTR) wID;

	   entries = resdir->NumberOfNamedEntries;

	   namelen = lstrlenW( lpwstr );

	   for (i=0;i<entries; i++) {

                PIMAGE_RESOURCE_DIR_STRING_U str =
                	MAKEPTR((PIMAGE_RESOURCE_DIR_STRING_U),
				root,
                        	et[i].u1.s.NameOffset);

                if(namelen != str->Length)
                        continue;

                if(lstrncmpiW( lpwstr, str->NameString, str->Length) == 0) {
                        subdir = MAKEPTR((PIMAGE_RESOURCE_DIRECTORY),
                                root,
                                et[i].u2.s.OffsetToDirectory);
			return subdir;
		}
	   }

	   subdir = MAKEPTR((PIMAGE_RESOURCE_DIRECTORY),
		    root, et[0].u2.s.OffsetToDirectory);
	} else {
	   entries = resdir->NumberOfNamedEntries+resdir->NumberOfIdEntries;
	   for (i=resdir->NumberOfNamedEntries;i<entries;i++) {

	       if(et[i].u1.Name == wID) {
	       	subdir = MAKEPTR((PIMAGE_RESOURCE_DIRECTORY),
		    root,
	    	    et[i].u2.s.OffsetToDirectory);
		return subdir;
	       }
	   }

	   subdir = MAKEPTR((PIMAGE_RESOURCE_DIRECTORY),
		    root, et[0].u2.s.OffsetToDirectory);
	}
	return subdir;
}

PIMAGE_RESOURCE_DIRECTORY
LoadResourceDirectory(MODULE_HEADERS *lpNTModule)
{
	DWORD BaseAddress; 
	PIMAGE_NT_HEADERS pNTHeader;
        IMAGE_DATA_DIRECTORY    dir;
	PIMAGE_RESOURCE_DIRECTORY resdir;

	if(lpNTModule == 0)
		return (PIMAGE_RESOURCE_DIRECTORY) 0;

	BaseAddress = (DWORD) lpNTModule->BaseAddress;
	pNTHeader = lpNTModule->pNTHeader;

	dir=pNTHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE];
	resdir = MAKEPTR((PIMAGE_RESOURCE_DIRECTORY),
		BaseAddress,
		dir.VirtualAddress);

	return resdir;
}

extern LCID GetUserDefaultLCID();

/***************************************************************/

void *
TWIN_LoadBin32MenuIndirect(void *p,HMENU *lphMenu)
{
	HMENU hMenu; 
	WORD   flags;
	WORD   id;
	int    len;
	char   MenuName[64];

	// this is the string data for this resource
	//logstr(LF_DEBUG,"menu resource data entry=%p\n",p);

	hMenu = CreateMenu();
	if(hMenu == 0 || p == 0)
		return 0;

	*lphMenu = hMenu;
	do {
		id = 0;
		flags = GETWORD(p);
		p += sizeof(SHORT);
	
		if((flags & MF_POPUP) ==0) {
			id    = GETWORD(p);
			p += sizeof(SHORT);
		}

		lstrcpyWtoA(MenuName,p);
		len = strlen(MenuName);
		if(len == 0)
			flags |= MF_SEPARATOR;
		len++;

		p += len*sizeof(SHORT);

		if (flags & MF_POPUP) {
			HMENU hNewMenu;
			p = TWIN_LoadBin32MenuIndirect(p,&hNewMenu);
			AppendMenu(hMenu, flags & ~MF_END, hNewMenu,MenuName);
		} else
			AppendMenu(hMenu, flags & ~MF_END, id,MenuName);

	} while (!(flags & MF_END));

	return p;
}

// assuming that lpstr is in WIDE format
// return hMenu in lphMenu, and 1 otherwise 
// return false
int 
LoadBin32MenuW(HINSTANCE hInstance, LPWSTR lpstr, HMENU *lphMenu)
{
	LPMODULEINFO modinfo;
	HMODULE     hModule;
	MODULE_HEADERS *lpNTModule;
	PIMAGE_RESOURCE_DIRECTORY resdir,rootdir;
	PIMAGE_RESOURCE_DATA_ENTRY dt;
	void	*p;
	LCID    lcid = GetUserDefaultLCID();
	WORD	version;
	HMENU   hMenu = 0;
	int     offset;

	logstr(LF_LOG,"LoadBin32Menu(HINSTANCE %x, LPCSTR %p, HMENU *%p)\n",
		hInstance,lpstr,lphMenu);

	// get the modinfo struct from the hInstance
	hModule = GetModuleFromInstance(hInstance);	
	modinfo = GETMODULEINFO(hModule);

	// we now have the bin32 structure for this hInstance
	lpNTModule = (MODULE_HEADERS *) modinfo->lpNTHeader;

	if (lpNTModule == 0) {
	   hMenu = LoadMenu(hInstance,(LPSTR)lpstr);
	   *lphMenu = hMenu;
	   return hMenu;
	}

	// load the root directory of resources
	rootdir = LoadResourceDirectory(lpNTModule);

	if (rootdir == 0)
	   return 0;

	// find the MENU type resource
	resdir = FindResourceDirectory(lpNTModule,rootdir,rootdir,(DWORD)RT_MENU,0);

	// find the WIDE menu we want
	resdir = FindResourceDirectory(lpNTModule,rootdir,resdir,(DWORD)lpstr/*MenuNameW*/,0);

	// find the one for our language, or the default
	dt     = (PIMAGE_RESOURCE_DATA_ENTRY) 
		FindResourceDirectory(lpNTModule,rootdir,resdir,lcid,0);

	p = MAKEPTR((void *), 
		lpNTModule->BaseAddress, dt->OffsetToData);

	version = GETWORD(p);
	p += sizeof(SHORT);	

	switch(version) {
		case 0:
			// pickup offset to menu
			offset = GETWORD(p);
			p += sizeof(SHORT);	

			// now pointing to binary template
			p += offset;

			TWIN_LoadBin32MenuIndirect(p,&hMenu);

			if(lphMenu)
				*lphMenu = hMenu;
			break;				

		case 1:
			break;
	}
	return hMenu;
}

HACCEL	
TWIN_LoadAccelerators32(HINSTANCE hInstance, LPCSTR lpTableName,int Style)
{
	logstr(LF_APISTUB,"LoadAccelerators32 \n");
	return 0;
}

HICON   
TWIN_LoadIcon32(HINSTANCE hInstance, LPCSTR lpIconName,int Style )
{
	logstr(LF_APISTUB,"LoadIcon32 \n");
	return 0;
}

HCURSOR 
TWIN_LoadCursor32(HINSTANCE hInstance, LPCSTR lpCursorRsrc,int Style)
{
	logstr(LF_APISTUB,"LoadCursor32 \n");
	return 0;
}

HMENU
TWIN_LoadMenu32(HINSTANCE hInstance, LPCTSTR lpstr,int Style)
{
	HMENU hMenu;
	short  MenuNameString[64];
	LPWSTR  lpMenuName = (LPWSTR) lpstr;

	if(HIWORD(lpstr)) {
		APISTR((LF_APICALL,"LoadMenuA(HINSTANCE=%x,LPCTSTR=%s)\n",
			hInstance,lpstr));

		/* convert ansi MENU name to  wide MENU name */
		lpMenuName = lstrcpynAtoW(MenuNameString,lpstr,64);
	} else
		APISTR((LF_APICALL,"LoadMenuA(HINSTANCE=%x,LPCTSTR=%p)\n",
			hInstance,lpstr));
	
	if(LoadBin32MenuW(hInstance, lpMenuName, &hMenu)) {
	        APISTR((LF_APIRET,"LoadMenuA: returns HMENU %d\n",hMenu));
		return hMenu;
	}

	APISTR((LF_APIRET,"LoadMenuA: returns HMENU 0\n"));
	return 0;
}

/***************************************************************/

static SHORT *
TWIN_LoadStringPointer(HINSTANCE hInstance, int wID,short *len)
{
	LPMODULEINFO modinfo;
	HMODULE     hModule;
	MODULE_HEADERS *lpNTModule;
	PIMAGE_RESOURCE_DIRECTORY resdir,rootdir;
	PIMAGE_RESOURCE_DATA_ENTRY dt;
	int major,minor,i;
	SHORT	*p;
	LCID    lcid = GetUserDefaultLCID();

	// get the modinfo struct from the hInstance
	hModule = GetModuleFromInstance(hInstance);	
	modinfo = GETMODULEINFO(hModule);

	// we now have the bin32 structure for this hInstance
	lpNTModule = (MODULE_HEADERS *) modinfo->lpNTHeader;

	// load the root directory of resources
	rootdir = LoadResourceDirectory(lpNTModule);

	if(rootdir == 0)
	  return 0;

	// which block of strings do we want
	major =  (wID >> 4) + 1;

	// which string of the list of 16 do we want
	minor = wID & 0xf;

	// find the STRING type resource
	resdir = FindResourceDirectory(lpNTModule,rootdir,rootdir,(DWORD) RT_STRING,0);

	// find the block of the string we want
	resdir = FindResourceDirectory(lpNTModule,rootdir,resdir,(DWORD) major,0);

	// find the one for our language, or the default
	dt     = (PIMAGE_RESOURCE_DATA_ENTRY) 
		FindResourceDirectory(lpNTModule,rootdir,resdir,lcid,0);

	//logstr(LF_DEBUG,"string resource data entry=%p %x, code=%x res=%x\n",
	//	dt,dt->CodePage,dt->Reserved);

	// this is the string data for this resource
	p = MAKEPTR((SHORT *), 
		lpNTModule->BaseAddress, dt->OffsetToData);

	// walk through it for the string index we want
	for(i=0;i<minor;i++) {
		p += *p + 1;
	}

	// return the length of the string, the first byte in the buffer
	*len = *p++;

	return p;
}

int
TWIN_LoadStringA(HINSTANCE hInstance, int wID, LPSTR lpstr,int nCount)
{
	SHORT *p;
	SHORT len;

	logstr(LF_API,"LoadStringA(HINSTANCE=%x,id=%x(%x,%x),lpstr=%p,nBytes=%d)\n",
		hInstance,wID,(wID>>4)+1,wID & 0xf,lpstr,nCount);
	
	p = TWIN_LoadStringPointer(hInstance, wID,&len);

	if(p) {
		memset(lpstr,0,nCount);
		// copy the actual data, AND a terminator
		lstrcpynWtoA(lpstr,p,min(nCount,len+1));
	} else
		*lpstr = 0;

	return lstrlen(lpstr);
}

int
TWIN_LoadStringW(HINSTANCE hInstance, int wID, LPWSTR lpstr,int nCount)
{
	SHORT *p;
	SHORT len;

	*lpstr = 0;

	logstr(LF_API,"LoadStringW(HINSTANCE=%x,id=%x(%x,%x),lpstr=%p,nBytes=%d)\n",
		hInstance,wID,(wID>>4)+1,wID & 0xf,lpstr,nCount);
	
	p = TWIN_LoadStringPointer(hInstance, wID,&len);

	if(p) {
		memset(lpstr,0,nCount);
		lstrcpynW(lpstr,p,min(nCount,len));
	} else
		*lpstr = 0;

	return lstrlenW(lpstr);
}


int
TWIN_LoadString32(HINSTANCE hInstance, UINT wID,LPSTR buffer,int len,int Style)
{
	if(Style)
		return TWIN_LoadStringW(hInstance,wID,(LPWSTR)buffer,len);
	return TWIN_LoadStringA(hInstance,wID,buffer,len);
}

static LPSTR std_controls[] = {
        "BUTTON",
        "EDIT",
        "STATIC",
        "LISTBOX",
        "SCROLLBAR",
        "COMBOBOX"
}; 

static LPBYTE
ConvertDlgTemplate32(HINSTANCE hInst, void *lpdt,BOOL bUniCode)
{
        DIALOGDATA *lpdd;
        CONTROLDATA *lpcd;
        int i,len;
	unsigned short *p;
	unsigned short rid;

	//DumpMemory("Convert Dialog Template",lpdt,64);
	p = (short *) lpdt;

        /* Begin to parse DLGTEMPLATE data into DIALOGDATA structure */

        if (!(lpdd = (DIALOGDATA *)WINMALLOC(sizeof(DIALOGDATA),0,0)))
                return NULL;

        lpdd->lStyle = GETDWORD(p); p++;p++;
	lpdd->dwExtStyle = GETDWORD(p); p++;p++;

        lpdd->bNumberOfItems = GETWORD(p); p++;

        lpdd->x = GETWORD(p); p++;
        lpdd->y = GETWORD(p); p++;

        lpdd->cx = GETWORD(p);p++;
	lpdd->cy = GETWORD(p);p++;
	lpdd->szMenuName = 0;
	lpdd->szClassName = 0;
	lpdd->szCaption = 0;
	lpdd->szFaceName = 0;

        /*  3 variable length strings follow DLGTEMPLATE */
	/*  get the first field value, don't move pointer yet */

	/* get id for menu */
	rid = GETWORD(p);

        /* first array is menu data, if its 0x0000 then no menu */
        if (rid) {
                if (rid == 0xffff)
                /*  if rid = 0xffff, then we have ordinal of menu */
                {
			p++;
			rid = GETWORD(p);p++;
                        LoadString(hInst, rid, lpdd->szMenuName, 256);
                }
                else
                /*  we have null terminated unicode string of menu resource */
                {
			if(bUniCode) {
				len = lstrlenW(p);
				lpdd->szMenuName = WINMALLOC(len,0,0);
				WideCharToMultiByte(0,0,p,0,lpdd->szMenuName,len,0,0);
			} else {
				len = lstrlen((LPSTR)p);
				lpdd->szMenuName = (LPSTR)p;
			}

			p += len;
                }
	}
	p++; 	/* skip over null */
       
	/* get id for class */
	rid = GETWORD(p);

        /* Second array is a class array that identifies the window 
	 * class of the control, if it is 0x0000 then it uses the 
	 * default dialog box class
	 */

        if (rid) {
                /* we have null terminated unicode string that 
		 * specifies the name of a registered window class
		 */
		if(bUniCode) {
			len = lstrlenW(p);
			lpdd->szClassName = WINMALLOC(len,0,0);
			WideCharToMultiByte(0,0,p,0,lpdd->szClassName,len,0,0);
		} else {
			len = lstrlen((LPSTR)p);
			lpdd->szClassName = (LPSTR) p;
		}
		p += len;
        } 
	p++;		/* skip over the null */
	
        /* Third array is the title array, if it is 0x00 then there is no
         *  title.  
 	 */
	rid = GETWORD(p);

        if (rid) {
                /* we have a null terminated unicode string that 
	 	 * specifies the title of the dialog 
		 */
		if(bUniCode) {
			len = lstrlenW(p);
			lpdd->szCaption = WINMALLOC(len,0,0);
			WideCharToMultiByte(0,0,p,0,lpdd->szCaption,len,0,0);
		} else {
			len = lstrlen((LPSTR)p);
			lpdd->szCaption = (LPSTR) p;
		}
		p += len;
        }
	p++;		/* skip over the null */

	/* this next item is only present if the DS_SETFONT bit is set */

        if (lpdd->lStyle & DS_SETFONT)
        /*  The 16 bit point size value and typeface array follow the title
            array, but only if the style member specifies DS_SETFONT */
        {
                lpdd->wPointSize = GETWORD(p);p++;
               
		if(bUniCode) {
			len = lstrlenW(p);
			lpdd->szFaceName = WINMALLOC(len,0,0);
			WideCharToMultiByte(0,0,p,0,lpdd->szFaceName,len,0,0);
		} else {
			len = lstrlen((LPSTR)p);
			lpdd->szFaceName = (LPSTR)p;
		}
		p += len;	
		p++;
        }

        if (lpdd->bNumberOfItems == 0)
        /*  if there are no controls then we're done */
        {
                lpdd->controlinfo = NULL;
                return (LPBYTE)lpdd;
        }

        lpcd = (CONTROLDATA *)WINMALLOC(
		sizeof(CONTROLDATA) * lpdd->bNumberOfItems,0,0);
        if (!lpcd)
                return NULL;

        for (i = 0; i < lpdd->bNumberOfItems; i++)
        {
		p = (unsigned short *)ALIGN_32BIT(p);

                /* create a CONTROLDATA structure for each DLGITEMTEMPLATE */
                lpcd[i].lStyle     = GETDWORD(p); p++;p++;
                lpcd[i].dwExtStyle = GETDWORD(p); p++;p++;

                lpcd[i].x = GETWORD(p); p++;
                lpcd[i].y = GETWORD(p); p++;
                lpcd[i].cx = GETWORD(p); p++;
                lpcd[i].cy = GETWORD(p); p++;
                lpcd[i].wID = GETWORD(p); p++;

		if (GETWORD(p) == 0xffff) {
			p++;
			rid = GETWORD(p); 
			lpcd[i].szClass = (LPSTR)WinStrdup(
				std_controls[rid & ~0x0080]);
		} else {
			if(bUniCode) {
				len = lstrlenW(p);
				lpcd[i].szClass = WINMALLOC(len,0,0);
				WideCharToMultiByte(0,0,p,0,lpcd[i].szClass,len,0,0);
			} else {
				len = lstrlen((LPSTR)p);
			        lpcd[i].szClass = (LPSTR)p;
			}
			p += len;
		}
		p++;

                if (GETWORD(p) == 0xffff) {
			p++;
                        lpcd[i].szText = (LPSTR)(int) GETWORD(p); 
                } else {
			if(bUniCode) {
				len = lstrlenW(p);
				lpcd[i].szText = WINMALLOC(len,0,0);
				WideCharToMultiByte(0,0,p,0,lpcd[i].szText,len,0,0);
			} else {
				len = lstrlen((LPSTR)p);
				lpcd[i].szText = (LPSTR) p;
			}
			p += len;
                }
		p++;

		rid = GETWORD(p); 
                if (rid)
                {
			p += rid/2;
                }
		p++;		/* over the null */

        }

        lpdd->controlinfo = lpcd;
        return (LPBYTE)lpdd;
}

HWND InternalCreateDialog(HINSTANCE,LPSTR,HWND,DLGPROC,LPARAM);

HWND 
CreateDialogParamA(HINSTANCE hInst,LPCSTR lpDialog,HWND hWnd,DLGPROC lpFunc,LPARAM lParam)
{
	HWND hDlg = 0;
	HMODULE  hModule;
	LPMODULEINFO modinfo;
	MODULE_HEADERS *lpNTModule;
	PIMAGE_RESOURCE_DIRECTORY resdir,rootdir;
	PIMAGE_RESOURCE_DATA_ENTRY dt;
	LCID    lcid = GetUserDefaultLCID();
	void   *lpDlgTemplate;
	DIALOGDATA *lpdd;

	
	APISTR((LF_APICALL,"CreateDialogParamA(%x,%p,%x,%p,%x)\n",
		hInst,lpDialog,hWnd,lpFunc,lParam));

	hModule = GetModuleFromInstance(hInst);	
	modinfo = GETMODULEINFO(hModule);
	
	// we now have the bin32 structure for this hInstance
	lpNTModule = (MODULE_HEADERS *) modinfo->lpNTHeader;

	if (lpNTModule == 0) {
	   hDlg = CreateDialogParam(hInst,lpDialog,hWnd,lpFunc,lParam);
	   APISTR((LF_APIRET,"CreateDialogParamA returns HWND %x\n",hDlg));
	   return hDlg;
	}

	// load the root directory of resources
	rootdir = LoadResourceDirectory(lpNTModule);

	if (rootdir == 0) {
	   APISTR((LF_APIRET,"CreateDialogParamA returns HWND %x\n",hDlg));
	   return hDlg;
	}

	// find the DIALOG type resource
	resdir = FindResourceDirectory(lpNTModule,rootdir,rootdir,(DWORD)RT_DIALOG,0);

	// find the ansi dialog we want
	// TODO this is NOT wide, its ansi
	resdir = FindResourceDirectory(lpNTModule,rootdir,resdir,(DWORD)lpDialog,1);

	// find the one for our language, or the default
	dt     = (PIMAGE_RESOURCE_DATA_ENTRY) 
		FindResourceDirectory(lpNTModule,rootdir,resdir,lcid,0);

	lpDlgTemplate = MAKEPTR((void *), 
		lpNTModule->BaseAddress, dt->OffsetToData);

	lpdd = (DIALOGDATA *)ConvertDlgTemplate32(hInst, lpDlgTemplate, TRUE);
	hDlg = InternalCreateDialog(hInst,(LPSTR)lpdd,hWnd,lpFunc,lParam);

	CleanupDialog((LPBYTE)lpdd);
	WinFree(lpdd);

	APISTR((LF_APIRET,"CreateDialogParamA returns HWND %x\n",hDlg));
	return hDlg;
}

HWND 
CreateDialogParamW(HINSTANCE hInst,LPCSTR lpDialog,HWND hWnd,DLGPROC lpFunc,LPARAM lParam)
{
	HWND hDlg = 0;
	HMODULE  hModule;
	LPMODULEINFO modinfo;
	MODULE_HEADERS *lpNTModule;
	PIMAGE_RESOURCE_DIRECTORY resdir,rootdir;
	PIMAGE_RESOURCE_DATA_ENTRY dt;
	LCID    lcid = GetUserDefaultLCID();
	void   *lpDlgTemplate;
	DIALOGDATA *lpdd;

	APISTR((LF_APICALL,"CreateDialogParamW(%x,%p,%x,%p,%x)\n",
		hInst,lpDialog,hWnd,lpFunc,lParam));

	hModule = GetModuleFromInstance(hInst);	
	modinfo = GETMODULEINFO(hModule);
	
	// we now have the bin32 structure for this hInstance
	lpNTModule = (MODULE_HEADERS *) modinfo->lpNTHeader;

	if (lpNTModule == 0) {
	   hDlg = CreateDialogParam(hInst,lpDialog,hWnd,lpFunc,lParam);
	   APISTR((LF_APIRET,"CreateDialogParamW returns HWND %x\n",hDlg));
	   return hDlg;
	}

	// load the root directory of resources
	rootdir = LoadResourceDirectory(lpNTModule);

	if (rootdir == 0) {
	   APISTR((LF_APIRET,"CreateDialogParamW returns HWND %x\n",hDlg));
	   return hDlg;
	}

	// find the DIALOG type resource
	resdir = FindResourceDirectory(lpNTModule,rootdir,rootdir,(DWORD)RT_DIALOG,0);

	// find the WIDE dialog we want
	resdir = FindResourceDirectory(lpNTModule,rootdir,resdir,(DWORD)lpDialog,0);

	// find the one for our language, or the default
	dt     = (PIMAGE_RESOURCE_DATA_ENTRY) 
		FindResourceDirectory(lpNTModule,rootdir,resdir,lcid,0);

	lpDlgTemplate = MAKEPTR((void *), 
		lpNTModule->BaseAddress, dt->OffsetToData);

	lpdd = (DIALOGDATA *)ConvertDlgTemplate32(hInst, lpDlgTemplate, TRUE);
	hDlg = InternalCreateDialog(hInst,(LPSTR)lpdd,hWnd,lpFunc,lParam);

	CleanupDialog((LPBYTE)lpdd);
	WinFree(lpdd);

	APISTR((LF_APIRET,"CreateDialogParamW returns HWND %x\n",hDlg));
	return hDlg;
}
