/*     
	MMBin.c	2.10
    	Copyright 1997 Willows Software, Inc. 

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.


For more information about the Willows Twin Libraries.

	http://www.willows.com	

To send email to the maintainer of the Willows Twin Libraries.

	mailto:twin@willows.com 

 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>


#define NOAPIPROTO

#include "windows.h"
#include "WinDefs.h"
#include "kerndef.h"
#include "Endian.h"
#include "Log.h"
#include "Kernel.h"
#include "Resources.h"
#include "DPMI.h"
#include "BinTypes.h"
#include "ModTable.h"

extern long int timeBeginPeriod();
extern long int timeEndPeriod();
extern long int timeGetDevCaps();
extern long int timeGetSystemTime();
extern long int timeGetTime();
extern long int timeKillEvent();
extern long int timeSetEvent();

extern long int waveOutGetNumDevs();

extern long int midiOutGetNumDevs();

extern long int mciSendCommand();
extern long int mciSendString();
extern long int mciGetDeviceID();
extern long int sndPlaySound();

extern long int Trap();
extern long int IT_V();
extern long int IT_1UI();
extern long int IT_TIMEGETSYSTEMTIME();
extern long int IT_TIMESETEVENT();
extern long int IT_TIMEGETDEVCAPS();

extern long int IT_1LP1UI();
extern long int IT_1H1UI2L();
extern long int IT_2LP1UI1H();
extern long int IT_1LP();

 /* Interface Segment Image MMSYSTEM: */

static long int (*seg_image_MMSYSTEM_0[])() =
#if !defined(TWIN_EMPTY_MODTABLE)
{	/* nil */	0, 0,
	/* 001 */	Trap, 0,
	/* 002 */	IT_1LP1UI, sndPlaySound,
	/* 003 */	Trap, 0,
	/* 004 */	Trap, 0,
	/* 005 */	Trap, 0,
	/* 006 */	Trap, 0,
	/* 007 */	Trap, 0,
	/* 008 */	Trap, 0,
	/* 009 */	Trap, 0,
	/* 00a */	Trap, 0,
	/* 00b */	Trap, 0,
	/* 00c */	Trap, 0,
	/* 00d */	Trap, 0,
	/* 00e */	Trap, 0,
	/* 00f */	Trap, 0,
	/* 010 */	Trap, 0,
	/* 011 */	Trap, 0,
	/* 012 */	Trap, 0,
	/* 013 */	Trap, 0,
	/* 014 */	Trap, 0,
	/* 015 */	Trap, 0,
	/* 016 */	Trap, 0,
	/* 017 */	Trap, 0,
	/* 018 */	Trap, 0,
	/* 019 */	Trap, 0,
	/* 01a */	Trap, 0,
	/* 01b */	Trap, 0,
	/* 01c */	Trap, 0,
	/* 01d */	Trap, 0,
	/* 01e */	Trap, 0,
	/* 01f */	Trap, 0,
	/* 020 */	Trap, 0,
	/* 021 */	Trap, 0,
	/* 022 */	Trap, 0,
	/* 023 */	Trap, 0,
	/* 024 */	Trap, 0,
	/* 025 */	Trap, 0,
	/* 026 */	Trap, 0,
	/* 027 */	Trap, 0,
	/* 028 */	Trap, 0,
	/* 029 */	Trap, 0,
	/* 02a */	Trap, 0,
	/* 02b */	Trap, 0,
	/* 02c */	Trap, 0,
	/* 02d */	Trap, 0,
	/* 02e */	Trap, 0,
	/* 02f */	Trap, 0,
	/* 030 */	Trap, 0,
	/* 031 */	Trap, 0,
	/* 032 */	Trap, 0,
	/* 033 */	Trap, 0,
	/* 034 */	Trap, 0,
	/* 035 */	Trap, 0,
	/* 036 */	Trap, 0,
	/* 037 */	Trap, 0,
	/* 038 */	Trap, 0,
	/* 039 */	Trap, 0,
	/* 03a */	Trap, 0,
	/* 03b */	Trap, 0,
	/* 03c */	Trap, 0,
	/* 03d */	Trap, 0,
	/* 03e */	Trap, 0,
	/* 03f */	Trap, 0,
	/* 040 */	Trap, 0,
	/* 041 */	Trap, 0,
	/* 042 */	Trap, 0,
	/* 043 */	Trap, 0,
	/* 044 */	Trap, 0,
	/* 045 */	Trap, 0,
	/* 046 */	Trap, 0,
	/* 047 */	Trap, 0,
	/* 048 */	Trap, 0,
	/* 049 */	Trap, 0,
	/* 04a */	Trap, 0,
	/* 04b */	Trap, 0,
	/* 04c */	Trap, 0,
	/* 04d */	Trap, 0,
	/* 04e */	Trap, 0,
	/* 04f */	Trap, 0,
	/* 050 */	Trap, 0,
	/* 051 */	Trap, 0,
	/* 052 */	Trap, 0,
	/* 053 */	Trap, 0,
	/* 054 */	Trap, 0,
	/* 055 */	Trap, 0,
	/* 056 */	Trap, 0,
	/* 057 */	Trap, 0,
	/* 058 */	Trap, 0,
	/* 059 */	Trap, 0,
	/* 05a */	Trap, 0,
	/* 05b */	Trap, 0,
	/* 05c */	Trap, 0,
	/* 05d */	Trap, 0,
	/* 05e */	Trap, 0,
	/* 05f */	Trap, 0,
	/* 060 */	Trap, 0,
	/* 061 */	Trap, 0,
	/* 062 */	Trap, 0,
	/* 063 */	Trap, 0,
	/* 064 */	Trap, 0,
	/* 065 */	Trap, 0,
	/* 066 */	Trap, 0,
	/* 067 */	Trap, 0,
	/* 068 */	Trap, 0,
	/* 069 */	Trap, 0,
	/* 06a */	Trap, 0,
	/* 06b */	Trap, 0,
	/* 06c */	Trap, 0,
	/* 06d */	Trap, 0,
	/* 06e */	Trap, 0,
	/* 06f */	Trap, 0,
	/* 070 */	Trap, 0,
	/* 071 */	Trap, 0,
	/* 072 */	Trap, 0,
	/* 073 */	Trap, 0,
	/* 074 */	Trap, 0,
	/* 075 */	Trap, 0,
	/* 076 */	Trap, 0,
	/* 077 */	Trap, 0,
	/* 078 */	Trap, 0,
	/* 079 */	Trap, 0,
	/* 07a */	Trap, 0,
	/* 07b */	Trap, 0,
	/* 07c */	Trap, 0,
	/* 07d */	Trap, 0,
	/* 07e */	Trap, 0,
	/* 07f */	Trap, 0,
	/* 080 */	Trap, 0,
	/* 081 */	Trap, 0,
	/* 082 */	Trap, 0,
	/* 083 */	Trap, 0,
	/* 084 */	Trap, 0,
	/* 085 */	Trap, 0,
	/* 086 */	Trap, 0,
	/* 087 */	Trap, 0,
	/* 088 */	Trap, 0,
	/* 089 */	Trap, 0,
	/* 08a */	Trap, 0,
	/* 08b */	Trap, 0,
	/* 08c */	Trap, 0,
	/* 08d */	Trap, 0,
	/* 08e */	Trap, 0,
	/* 08f */	Trap, 0,
	/* 090 */	Trap, 0,
	/* 091 */	Trap, 0,
	/* 092 */	Trap, 0,
	/* 093 */	Trap, 0,
	/* 094 */	Trap, 0,
	/* 095 */	Trap, 0,
	/* 096 */	Trap, 0,
	/* 097 */	Trap, 0,
	/* 098 */	Trap, 0,
	/* 099 */	Trap, 0,
	/* 09a */	Trap, 0,
	/* 09b */	Trap, 0,
	/* 09c */	Trap, 0,
	/* 09d */	Trap, 0,
	/* 09e */	Trap, 0,
	/* 09f */	Trap, 0,
	/* 0a0 */	Trap, 0,
	/* 0a1 */	Trap, 0,
	/* 0a2 */	Trap, 0,
	/* 0a3 */	Trap, 0,
	/* 0a4 */	Trap, 0,
	/* 0a5 */	Trap, 0,
	/* 0a6 */	Trap, 0,
	/* 0a7 */	Trap, 0,
	/* 0a8 */	Trap, 0,
	/* 0a9 */	Trap, 0,
	/* 0aa */	Trap, 0,
	/* 0ab */	Trap, 0,
	/* 0ac */	Trap, 0,
	/* 0ad */	Trap, 0,
	/* 0ae */	Trap, 0,
	/* 0af */	Trap, 0,
	/* 0b0 */	Trap, 0,
	/* 0b1 */	Trap, 0,
	/* 0b2 */	Trap, 0,
	/* 0b3 */	Trap, 0,
	/* 0b4 */	Trap, 0,
	/* 0b5 */	Trap, 0,
	/* 0b6 */	Trap, 0,
	/* 0b7 */	Trap, 0,
	/* 0b8 */	Trap, 0,
	/* 0b9 */	Trap, 0,
	/* 0ba */	Trap, 0,
	/* 0bb */	Trap, 0,
	/* 0bc */	Trap, 0,
	/* 0bd */	Trap, 0,
	/* 0be */	Trap, 0,
	/* 0bf */	Trap, 0,
	/* 0c0 */	Trap, 0,
	/* 0c1 */	Trap, 0,
	/* 0c2 */	Trap, 0,
	/* 0c3 */	Trap, 0,
	/* 0c4 */	Trap, 0,
	/* 0c5 */	Trap, 0,
	/* 0c6 */	Trap, 0,
	/* 0c7 */	Trap, 0,
	/* 0c8 */	Trap, 0,
	/* 0c9 */	IT_V, midiOutGetNumDevs,
	/* 0ca */	Trap, 0,
	/* 0cb */	Trap, 0,
	/* 0cc */	Trap, 0,
	/* 0cd */	Trap, 0,
	/* 0ce */	Trap, 0,
	/* 0cf */	Trap, 0,
	/* 0d0 */	Trap, 0,
	/* 0d1 */	Trap, 0,
	/* 0d2 */	Trap, 0,
	/* 0d3 */	Trap, 0,
	/* 0d4 */	Trap, 0,
	/* 0d5 */	Trap, 0,
	/* 0d6 */	Trap, 0,
	/* 0d7 */	Trap, 0,
	/* 0d8 */	Trap, 0,
	/* 0d9 */	Trap, 0,
	/* 0da */	Trap, 0,
	/* 0db */	Trap, 0,
	/* 0dc */	Trap, 0,
	/* 0dd */	Trap, 0,
	/* 0de */	Trap, 0,
	/* 0df */	Trap, 0,
	/* 0e0 */	Trap, 0,
	/* 0e1 */	Trap, 0,
	/* 0e2 */	Trap, 0,
	/* 0e3 */	Trap, 0,
	/* 0e4 */	Trap, 0,
	/* 0e5 */	Trap, 0,
	/* 0e6 */	Trap, 0,
	/* 0e7 */	Trap, 0,
	/* 0e8 */	Trap, 0,
	/* 0e9 */	Trap, 0,
	/* 0ea */	Trap, 0,
	/* 0eb */	Trap, 0,
	/* 0ec */	Trap, 0,
	/* 0ed */	Trap, 0,
	/* 0ee */	Trap, 0,
	/* 0ef */	Trap, 0,
	/* 0f0 */	Trap, 0,
	/* 0f1 */	Trap, 0,
	/* 0f2 */	Trap, 0,
	/* 0f3 */	Trap, 0,
	/* 0f4 */	Trap, 0,
	/* 0f5 */	Trap, 0,
	/* 0f6 */	Trap, 0,
	/* 0f7 */	Trap, 0,
	/* 0f8 */	Trap, 0,
	/* 0f9 */	Trap, 0,
	/* 0fa */	Trap, 0,
	/* 0fb */	Trap, 0,
	/* 0fc */	Trap, 0,
	/* 0fd */	Trap, 0,
	/* 0fe */	Trap, 0,
	/* 0ff */	Trap, 0,
	/* 100 */	Trap, 0,
	/* 101 */	Trap, 0,
	/* 102 */	Trap, 0,
	/* 103 */	Trap, 0,
	/* 104 */	Trap, 0,
	/* 105 */	Trap, 0,
	/* 106 */	Trap, 0,
	/* 107 */	Trap, 0,
	/* 108 */	Trap, 0,
	/* 109 */	Trap, 0,
	/* 10a */	Trap, 0,
	/* 10b */	Trap, 0,
	/* 10c */	Trap, 0,
	/* 10d */	Trap, 0,
	/* 10e */	Trap, 0,
	/* 10f */	Trap, 0,
	/* 110 */	Trap, 0,
	/* 111 */	Trap, 0,
	/* 112 */	Trap, 0,
	/* 113 */	Trap, 0,
	/* 114 */	Trap, 0,
	/* 115 */	Trap, 0,
	/* 116 */	Trap, 0,
	/* 117 */	Trap, 0,
	/* 118 */	Trap, 0,
	/* 119 */	Trap, 0,
	/* 11a */	Trap, 0,
	/* 11b */	Trap, 0,
	/* 11c */	Trap, 0,
	/* 11d */	Trap, 0,
	/* 11e */	Trap, 0,
	/* 11f */	Trap, 0,
	/* 120 */	Trap, 0,
	/* 121 */	Trap, 0,
	/* 122 */	Trap, 0,
	/* 123 */	Trap, 0,
	/* 124 */	Trap, 0,
	/* 125 */	Trap, 0,
	/* 126 */	Trap, 0,
	/* 127 */	Trap, 0,
	/* 128 */	Trap, 0,
	/* 129 */	Trap, 0,
	/* 12a */	Trap, 0,
	/* 12b */	Trap, 0,
	/* 12c */	Trap, 0,
	/* 12d */	Trap, 0,
	/* 12e */	Trap, 0,
	/* 12f */	Trap, 0,
	/* 130 */	Trap, 0,
	/* 131 */	Trap, 0,
	/* 132 */	Trap, 0,
	/* 133 */	Trap, 0,
	/* 134 */	Trap, 0,
	/* 135 */	Trap, 0,
	/* 136 */	Trap, 0,
	/* 137 */	Trap, 0,
	/* 138 */	Trap, 0,
	/* 139 */	Trap, 0,
	/* 13a */	Trap, 0,
	/* 13b */	Trap, 0,
	/* 13c */	Trap, 0,
	/* 13d */	Trap, 0,
	/* 13e */	Trap, 0,
	/* 13f */	Trap, 0,
	/* 140 */	Trap, 0,
	/* 141 */	Trap, 0,
	/* 142 */	Trap, 0,
	/* 143 */	Trap, 0,
	/* 144 */	Trap, 0,
	/* 145 */	Trap, 0,
	/* 146 */	Trap, 0,
	/* 147 */	Trap, 0,
	/* 148 */	Trap, 0,
	/* 149 */	Trap, 0,
	/* 14a */	Trap, 0,
	/* 14b */	Trap, 0,
	/* 14c */	Trap, 0,
	/* 14d */	Trap, 0,
	/* 14e */	Trap, 0,
	/* 14f */	Trap, 0,
	/* 150 */	Trap, 0,
	/* 151 */	Trap, 0,
	/* 152 */	Trap, 0,
	/* 153 */	Trap, 0,
	/* 154 */	Trap, 0,
	/* 155 */	Trap, 0,
	/* 156 */	Trap, 0,
	/* 157 */	Trap, 0,
	/* 158 */	Trap, 0,
	/* 159 */	Trap, 0,
	/* 15a */	Trap, 0,
	/* 15b */	Trap, 0,
	/* 15c */	Trap, 0,
	/* 15d */	Trap, 0,
	/* 15e */	Trap, 0,
	/* 15f */	Trap, 0,
	/* 160 */	Trap, 0,
	/* 161 */	Trap, 0,
	/* 162 */	Trap, 0,
	/* 163 */	Trap, 0,
	/* 164 */	Trap, 0,
	/* 165 */	Trap, 0,
	/* 166 */	Trap, 0,
	/* 167 */	Trap, 0,
	/* 168 */	Trap, 0,
	/* 169 */	Trap, 0,
	/* 16a */	Trap, 0,
	/* 16b */	Trap, 0,
	/* 16c */	Trap, 0,
	/* 16d */	Trap, 0,
	/* 16e */	Trap, 0,
	/* 16f */	Trap, 0,
	/* 170 */	Trap, 0,
	/* 171 */	Trap, 0,
	/* 172 */	Trap, 0,
	/* 173 */	Trap, 0,
	/* 174 */	Trap, 0,
	/* 175 */	Trap, 0,
	/* 176 */	Trap, 0,
	/* 177 */	Trap, 0,
	/* 178 */	Trap, 0,
	/* 179 */	Trap, 0,
	/* 17a */	Trap, 0,
	/* 17b */	Trap, 0,
	/* 17c */	Trap, 0,
	/* 17d */	Trap, 0,
	/* 17e */	Trap, 0,
	/* 17f */	Trap, 0,
	/* 180 */	Trap, 0,
	/* 181 */	Trap, 0,
	/* 182 */	Trap, 0,
	/* 183 */	Trap, 0,
	/* 184 */	Trap, 0,
	/* 185 */	Trap, 0,
	/* 186 */	Trap, 0,
	/* 187 */	Trap, 0,
	/* 188 */	Trap, 0,
	/* 189 */	Trap, 0,
	/* 18a */	Trap, 0,
	/* 18b */	Trap, 0,
	/* 18c */	Trap, 0,
	/* 18d */	Trap, 0,
	/* 18e */	Trap, 0,
	/* 18f */	Trap, 0,
	/* 190 */	Trap, 0,
	/* 191 */	IT_V, waveOutGetNumDevs,
	/* 192 */	Trap, 0,
	/* 193 */	Trap, 0,
	/* 194 */	Trap, 0,
	/* 195 */	Trap, 0,
	/* 196 */	Trap, 0,
	/* 197 */	Trap, 0,
	/* 198 */	Trap, 0,
	/* 199 */	Trap, 0,
	/* 19a */	Trap, 0,
	/* 19b */	Trap, 0,
	/* 19c */	Trap, 0,
	/* 19d */	Trap, 0,
	/* 19e */	Trap, 0,
	/* 19f */	Trap, 0,
	/* 1a0 */	Trap, 0,
	/* 1a1 */	Trap, 0,
	/* 1a2 */	Trap, 0,
	/* 1a3 */	Trap, 0,
	/* 1a4 */	Trap, 0,
	/* 1a5 */	Trap, 0,
	/* 1a6 */	Trap, 0,
	/* 1a7 */	Trap, 0,
	/* 1a8 */	Trap, 0,
	/* 1a9 */	Trap, 0,
	/* 1aa */	Trap, 0,
	/* 1ab */	Trap, 0,
	/* 1ac */	Trap, 0,
	/* 1ad */	Trap, 0,
	/* 1ae */	Trap, 0,
	/* 1af */	Trap, 0,
	/* 1b0 */	Trap, 0,
	/* 1b1 */	Trap, 0,
	/* 1b2 */	Trap, 0,
	/* 1b3 */	Trap, 0,
	/* 1b4 */	Trap, 0,
	/* 1b5 */	Trap, 0,
	/* 1b6 */	Trap, 0,
	/* 1b7 */	Trap, 0,
	/* 1b8 */	Trap, 0,
	/* 1b9 */	Trap, 0,
	/* 1ba */	Trap, 0,
	/* 1bb */	Trap, 0,
	/* 1bc */	Trap, 0,
	/* 1bd */	Trap, 0,
	/* 1be */	Trap, 0,
	/* 1bf */	Trap, 0,
	/* 1c0 */	Trap, 0,
	/* 1c1 */	Trap, 0,
	/* 1c2 */	Trap, 0,
	/* 1c3 */	Trap, 0,
	/* 1c4 */	Trap, 0,
	/* 1c5 */	Trap, 0,
	/* 1c6 */	Trap, 0,
	/* 1c7 */	Trap, 0,
	/* 1c8 */	Trap, 0,
	/* 1c9 */	Trap, 0,
	/* 1ca */	Trap, 0,
	/* 1cb */	Trap, 0,
	/* 1cc */	Trap, 0,
	/* 1cd */	Trap, 0,
	/* 1ce */	Trap, 0,
	/* 1cf */	Trap, 0,
	/* 1d0 */	Trap, 0,
	/* 1d1 */	Trap, 0,
	/* 1d2 */	Trap, 0,
	/* 1d3 */	Trap, 0,
	/* 1d4 */	Trap, 0,
	/* 1d5 */	Trap, 0,
	/* 1d6 */	Trap, 0,
	/* 1d7 */	Trap, 0,
	/* 1d8 */	Trap, 0,
	/* 1d9 */	Trap, 0,
	/* 1da */	Trap, 0,
	/* 1db */	Trap, 0,
	/* 1dc */	Trap, 0,
	/* 1dd */	Trap, 0,
	/* 1de */	Trap, 0,
	/* 1df */	Trap, 0,
	/* 1e0 */	Trap, 0,
	/* 1e1 */	Trap, 0,
	/* 1e2 */	Trap, 0,
	/* 1e3 */	Trap, 0,
	/* 1e4 */	Trap, 0,
	/* 1e5 */	Trap, 0,
	/* 1e6 */	Trap, 0,
	/* 1e7 */	Trap, 0,
	/* 1e8 */	Trap, 0,
	/* 1e9 */	Trap, 0,
	/* 1ea */	Trap, 0,
	/* 1eb */	Trap, 0,
	/* 1ec */	Trap, 0,
	/* 1ed */	Trap, 0,
	/* 1ee */	Trap, 0,
	/* 1ef */	Trap, 0,
	/* 1f0 */	Trap, 0,
	/* 1f1 */	Trap, 0,
	/* 1f2 */	Trap, 0,
	/* 1f3 */	Trap, 0,
	/* 1f4 */	Trap, 0,
	/* 1f5 */	Trap, 0,
	/* 1f6 */	Trap, 0,
	/* 1f7 */	Trap, 0,
	/* 1f8 */	Trap, 0,
	/* 1f9 */	Trap, 0,
	/* 1fa */	Trap, 0,
	/* 1fb */	Trap, 0,
	/* 1fc */	Trap, 0,
	/* 1fd */	Trap, 0,
	/* 1fe */	Trap, 0,
	/* 1ff */	Trap, 0,
	/* 200 */	Trap, 0,
	/* 201 */	Trap, 0,
	/* 202 */	Trap, 0,
	/* 203 */	Trap, 0,
	/* 204 */	Trap, 0,
	/* 205 */	Trap, 0,
	/* 206 */	Trap, 0,
	/* 207 */	Trap, 0,
	/* 208 */	Trap, 0,
	/* 209 */	Trap, 0,
	/* 20a */	Trap, 0,
	/* 20b */	Trap, 0,
	/* 20c */	Trap, 0,
	/* 20d */	Trap, 0,
	/* 20e */	Trap, 0,
	/* 20f */	Trap, 0,
	/* 210 */	Trap, 0,
	/* 211 */	Trap, 0,
	/* 212 */	Trap, 0,
	/* 213 */	Trap, 0,
	/* 214 */	Trap, 0,
	/* 215 */	Trap, 0,
	/* 216 */	Trap, 0,
	/* 217 */	Trap, 0,
	/* 218 */	Trap, 0,
	/* 219 */	Trap, 0,
	/* 21a */	Trap, 0,
	/* 21b */	Trap, 0,
	/* 21c */	Trap, 0,
	/* 21d */	Trap, 0,
	/* 21e */	Trap, 0,
	/* 21f */	Trap, 0,
	/* 220 */	Trap, 0,
	/* 221 */	Trap, 0,
	/* 222 */	Trap, 0,
	/* 223 */	Trap, 0,
	/* 224 */	Trap, 0,
	/* 225 */	Trap, 0,
	/* 226 */	Trap, 0,
	/* 227 */	Trap, 0,
	/* 228 */	Trap, 0,
	/* 229 */	Trap, 0,
	/* 22a */	Trap, 0,
	/* 22b */	Trap, 0,
	/* 22c */	Trap, 0,
	/* 22d */	Trap, 0,
	/* 22e */	Trap, 0,
	/* 22f */	Trap, 0,
	/* 230 */	Trap, 0,
	/* 231 */	Trap, 0,
	/* 232 */	Trap, 0,
	/* 233 */	Trap, 0,
	/* 234 */	Trap, 0,
	/* 235 */	Trap, 0,
	/* 236 */	Trap, 0,
	/* 237 */	Trap, 0,
	/* 238 */	Trap, 0,
	/* 239 */	Trap, 0,
	/* 23a */	Trap, 0,
	/* 23b */	Trap, 0,
	/* 23c */	Trap, 0,
	/* 23d */	Trap, 0,
	/* 23e */	Trap, 0,
	/* 23f */	Trap, 0,
	/* 240 */	Trap, 0,
	/* 241 */	Trap, 0,
	/* 242 */	Trap, 0,
	/* 243 */	Trap, 0,
	/* 244 */	Trap, 0,
	/* 245 */	Trap, 0,
	/* 246 */	Trap, 0,
	/* 247 */	Trap, 0,
	/* 248 */	Trap, 0,
	/* 249 */	Trap, 0,
	/* 24a */	Trap, 0,
	/* 24b */	Trap, 0,
	/* 24c */	Trap, 0,
	/* 24d */	Trap, 0,
	/* 24e */	Trap, 0,
	/* 24f */	Trap, 0,
	/* 250 */	Trap, 0,
	/* 251 */	Trap, 0,
	/* 252 */	Trap, 0,
	/* 253 */	Trap, 0,
	/* 254 */	Trap, 0,
	/* 255 */	Trap, 0,
	/* 256 */	Trap, 0,
	/* 257 */	Trap, 0,
	/* 258 */	Trap, 0,
	/* 259 */	IT_TIMEGETSYSTEMTIME, timeGetSystemTime,
	/* 25a */	IT_TIMESETEVENT, timeSetEvent,
	/* 25b */	IT_1UI, timeKillEvent,
	/* 25c */	IT_TIMEGETDEVCAPS, timeGetDevCaps,
	/* 25d */	IT_1UI, timeBeginPeriod,
	/* 25e */	IT_1UI, timeEndPeriod,
	/* 25f */	IT_V, timeGetTime,
	/* 260 */	Trap, 0,
	/* 261 */	Trap, 0,
	/* 262 */	Trap, 0,
	/* 263 */	Trap, 0,
	/* 264 */	Trap, 0,
	/* 265 */	Trap, 0,
	/* 266 */	Trap, 0,
	/* 267 */	Trap, 0,
	/* 268 */	Trap, 0,
	/* 269 */	Trap, 0,
	/* 26a */	Trap, 0,
	/* 26b */	Trap, 0,
	/* 26c */	Trap, 0,
	/* 26d */	Trap, 0,
	/* 26e */	Trap, 0,
	/* 26f */	Trap, 0,
	/* 270 */	Trap, 0,
	/* 271 */	Trap, 0,
	/* 272 */	Trap, 0,
	/* 273 */	Trap, 0,
	/* 274 */	Trap, 0,
	/* 275 */	Trap, 0,
	/* 276 */	Trap, 0,
	/* 277 */	Trap, 0,
	/* 278 */	Trap, 0,
	/* 279 */	Trap, 0,
	/* 27a */	Trap, 0,
	/* 27b */	Trap, 0,
	/* 27c */	Trap, 0,
	/* 27d */	Trap, 0,
	/* 27e */	Trap, 0,
	/* 27f */	Trap, 0,
	/* 280 */	Trap, 0,
	/* 281 */	Trap, 0,
	/* 282 */	Trap, 0,
	/* 283 */	Trap, 0,
	/* 284 */	Trap, 0,
	/* 285 */	Trap, 0,
	/* 286 */	Trap, 0,
	/* 287 */	Trap, 0,
	/* 288 */	Trap, 0,
	/* 289 */	Trap, 0,
	/* 28a */	Trap, 0,
	/* 28b */	Trap, 0,
	/* 28c */	Trap, 0,
	/* 28d */	Trap, 0,
	/* 28e */	Trap, 0,
	/* 28f */	Trap, 0,
	/* 290 */	Trap, 0,
	/* 291 */	Trap, 0,
	/* 292 */	Trap, 0,
	/* 293 */	Trap, 0,
	/* 294 */	Trap, 0,
	/* 295 */	Trap, 0,
	/* 296 */	Trap, 0,
	/* 297 */	Trap, 0,
	/* 298 */	Trap, 0,
	/* 299 */	Trap, 0,
	/* 29a */	Trap, 0,
	/* 29b */	Trap, 0,
	/* 29c */	Trap, 0,
	/* 29d */	Trap, 0,
	/* 29e */	Trap, 0,
	/* 29f */	Trap, 0,
	/* 2a0 */	Trap, 0,
	/* 2a1 */	Trap, 0,
	/* 2a2 */	Trap, 0,
	/* 2a3 */	Trap, 0,
	/* 2a4 */	Trap, 0,
	/* 2a5 */	Trap, 0,
	/* 2a6 */	Trap, 0,
	/* 2a7 */	Trap, 0,
	/* 2a8 */	Trap, 0,
	/* 2a9 */	Trap, 0,
	/* 2aa */	Trap, 0,
	/* 2ab */	Trap, 0,
	/* 2ac */	Trap, 0,
	/* 2ad */	Trap, 0,
	/* 2ae */	Trap, 0,
	/* 2af */	Trap, 0,
	/* 2b0 */	Trap, 0,
	/* 2b1 */	Trap, 0,
	/* 2b2 */	Trap, 0,
	/* 2b3 */	Trap, 0,
	/* 2b4 */	Trap, 0,
	/* 2b5 */	Trap, 0,
	/* 2b6 */	Trap, 0,
	/* 2b7 */	Trap, 0,
	/* 2b8 */	Trap, 0,
	/* 2b9 */	Trap, 0,
	/* 2ba */	Trap, 0,
	/* 2bb */	Trap, 0,
	/* 2bc */	Trap, 0,
	/* 2bd */	IT_1H1UI2L, mciSendCommand,
	/* 2be */	IT_2LP1UI1H, mciSendString,
	/* 2bf */	IT_1LP, mciGetDeviceID,
	/* 2c0 */	Trap, 0,
	/* 2c1 */	Trap, 0,
	/* 2c2 */	Trap, 0,
	/* 2c3 */	Trap, 0,
	/* 2c4 */	Trap, 0,
	/* 2c5 */	Trap, 0,
	/* 2c6 */	Trap, 0,
	/* 2c7 */	Trap, 0,
	/* 2c8 */	Trap, 0,
	/* 2c9 */	Trap, 0,
	/* 2ca */	Trap, 0,
	/* 2cb */	Trap, 0,
	/* 2cc */	Trap, 0,
	/* 2cd */	Trap, 0,
	/* 2ce */	Trap, 0,
	/* 2cf */	Trap, 0,
	/* 2d0 */	Trap, 0,
	/* 2d1 */	Trap, 0,
	/* 2d2 */	Trap, 0,
	/* 2d3 */	Trap, 0,
	/* 2d4 */	Trap, 0,
	/* 2d5 */	Trap, 0,
	/* 2d6 */	Trap, 0,
	/* 2d7 */	Trap, 0,
	/* 2d8 */	Trap, 0,
	/* 2d9 */	Trap, 0,
	/* 2da */	Trap, 0,
	/* 2db */	Trap, 0,
	/* 2dc */	Trap, 0,
	/* 2dd */	Trap, 0,
	/* 2de */	Trap, 0,
	/* 2df */	Trap, 0,
	/* 2e0 */	Trap, 0,
	/* 2e1 */	Trap, 0,
	/* 2e2 */	Trap, 0,
	/* 2e3 */	Trap, 0,
	/* 2e4 */	Trap, 0,
	/* 2e5 */	Trap, 0,
	/* 2e6 */	Trap, 0,
	/* 2e7 */	Trap, 0,
	/* 2e8 */	Trap, 0,
	/* 2e9 */	Trap, 0,
	/* 2ea */	Trap, 0,
	/* 2eb */	Trap, 0,
	/* 2ec */	Trap, 0,
	/* 2ed */	Trap, 0,
	/* 2ee */	Trap, 0,
	/* 2ef */	Trap, 0,
	/* 2f0 */	Trap, 0,
	/* 2f1 */	Trap, 0,
	/* 2f2 */	Trap, 0,
	/* 2f3 */	Trap, 0,
	/* 2f4 */	Trap, 0,
	/* 2f5 */	Trap, 0,
	/* 2f6 */	Trap, 0,
	/* 2f7 */	Trap, 0,
	/* 2f8 */	Trap, 0,
	/* 2f9 */	Trap, 0,
	/* 2fa */	Trap, 0,
	/* 2fb */	Trap, 0,
	/* 2fc */	Trap, 0,
	/* 2fd */	Trap, 0,
	/* 2fe */	Trap, 0,
	/* 2ff */	Trap, 0,
	/* 300 */	Trap, 0,
	/* 301 */	Trap, 0,
	/* 302 */	Trap, 0,
	/* 303 */	Trap, 0,
	/* 304 */	Trap, 0,
	/* 305 */	Trap, 0,
	/* 306 */	Trap, 0,
	/* 307 */	Trap, 0,
	/* 308 */	Trap, 0,
	/* 309 */	Trap, 0,
	/* 30a */	Trap, 0,
	/* 30b */	Trap, 0,
	/* 30c */	Trap, 0,
	/* 30d */	Trap, 0,
	/* 30e */	Trap, 0,
	/* 30f */	Trap, 0,
	/* 310 */	Trap, 0,
	/* 311 */	Trap, 0,
	/* 312 */	Trap, 0,
	/* 313 */	Trap, 0,
	/* 314 */	Trap, 0,
	/* 315 */	Trap, 0,
	/* 316 */	Trap, 0,
	/* 317 */	Trap, 0,
	/* 318 */	Trap, 0,
	/* 319 */	Trap, 0,
	/* 31a */	Trap, 0,
	/* 31b */	Trap, 0,
	/* 31c */	Trap, 0,
	/* 31d */	Trap, 0,
	/* 31e */	Trap, 0,
	/* 31f */	Trap, 0,
	/* 320 */	Trap, 0,
	/* 321 */	Trap, 0,
	/* 322 */	Trap, 0,
	/* 323 */	Trap, 0,
	/* 324 */	Trap, 0,
	/* 325 */	Trap, 0,
	/* 326 */	Trap, 0,
	/* 327 */	Trap, 0,
	/* 328 */	Trap, 0,
	/* 329 */	Trap, 0,
	/* 32a */	Trap, 0,
	/* 32b */	Trap, 0,
	/* 32c */	Trap, 0,
	/* 32d */	Trap, 0,
	/* 32e */	Trap, 0,
	/* 32f */	Trap, 0,
	/* 330 */	Trap, 0,
	/* 331 */	Trap, 0,
	/* 332 */	Trap, 0,
	/* 333 */	Trap, 0,
	/* 334 */	Trap, 0,
	/* 335 */	Trap, 0,
	/* 336 */	Trap, 0,
	/* 337 */	Trap, 0,
	/* 338 */	Trap, 0,
	/* 339 */	Trap, 0,
	/* 33a */	Trap, 0,
	/* 33b */	Trap, 0,
	/* 33c */	Trap, 0,
	/* 33d */	Trap, 0,
	/* 33e */	Trap, 0,
	/* 33f */	Trap, 0,
	/* 340 */	Trap, 0,
	/* 341 */	Trap, 0,
	/* 342 */	Trap, 0,
	/* 343 */	Trap, 0,
	/* 344 */	Trap, 0,
	/* 345 */	Trap, 0,
	/* 346 */	Trap, 0,
	/* 347 */	Trap, 0,
	/* 348 */	Trap, 0,
	/* 349 */	Trap, 0,
	/* 34a */	Trap, 0,
	/* 34b */	Trap, 0,
	/* 34c */	Trap, 0,
	/* 34d */	Trap, 0,
	/* 34e */	Trap, 0,
	/* 34f */	Trap, 0,
	/* 350 */	Trap, 0,
	/* 351 */	Trap, 0,
	/* 352 */	Trap, 0,
	/* 353 */	Trap, 0,
	/* 354 */	Trap, 0,
	/* 355 */	Trap, 0,
	/* 356 */	Trap, 0,
	/* 357 */	Trap, 0,
	/* 358 */	Trap, 0,
	/* 359 */	Trap, 0,
	/* 35a */	Trap, 0,
	/* 35b */	Trap, 0,
	/* 35c */	Trap, 0,
	/* 35d */	Trap, 0,
	/* 35e */	Trap, 0,
	/* 35f */	Trap, 0,
	/* 360 */	Trap, 0,
	/* 361 */	Trap, 0,
	/* 362 */	Trap, 0,
	/* 363 */	Trap, 0,
	/* 364 */	Trap, 0,
	/* 365 */	Trap, 0,
	/* 366 */	Trap, 0,
	/* 367 */	Trap, 0,
	/* 368 */	Trap, 0,
	/* 369 */	Trap, 0,
	/* 36a */	Trap, 0,
	/* 36b */	Trap, 0,
	/* 36c */	Trap, 0,
	/* 36d */	Trap, 0,
	/* 36e */	Trap, 0,
	/* 36f */	Trap, 0,
	/* 370 */	Trap, 0,
	/* 371 */	Trap, 0,
	/* 372 */	Trap, 0,
	/* 373 */	Trap, 0,
	/* 374 */	Trap, 0,
	/* 375 */	Trap, 0,
	/* 376 */	Trap, 0,
	/* 377 */	Trap, 0,
	/* 378 */	Trap, 0,
	/* 379 */	Trap, 0,
	/* 37a */	Trap, 0,
	/* 37b */	Trap, 0,
	/* 37c */	Trap, 0,
	/* 37d */	Trap, 0,
	/* 37e */	Trap, 0,
	/* 37f */	Trap, 0,
	/* 380 */	Trap, 0,
	/* 381 */	Trap, 0,
	/* 382 */	Trap, 0,
	/* 383 */	Trap, 0,
	/* 384 */	Trap, 0,
	/* 385 */	Trap, 0,
	/* 386 */	Trap, 0,
	/* 387 */	Trap, 0,
	/* 388 */	Trap, 0,
	/* 389 */	Trap, 0,
	/* 38a */	Trap, 0,
	/* 38b */	Trap, 0,
	/* 38c */	Trap, 0,
	/* 38d */	Trap, 0,
	/* 38e */	Trap, 0,
	/* 38f */	Trap, 0,
	/* 390 */	Trap, 0,
	/* 391 */	Trap, 0,
	/* 392 */	Trap, 0,
	/* 393 */	Trap, 0,
	/* 394 */	Trap, 0,
	/* 395 */	Trap, 0,
	/* 396 */	Trap, 0,
	/* 397 */	Trap, 0,
	/* 398 */	Trap, 0,
	/* 399 */	Trap, 0,
	/* 39a */	Trap, 0,
	/* 39b */	Trap, 0,
	/* 39c */	Trap, 0,
	/* 39d */	Trap, 0,
	/* 39e */	Trap, 0,
	/* 39f */	Trap, 0,
	/* 3a0 */	Trap, 0,
	/* 3a1 */	Trap, 0,
	/* 3a2 */	Trap, 0,
	/* 3a3 */	Trap, 0,
	/* 3a4 */	Trap, 0,
	/* 3a5 */	Trap, 0,
	/* 3a6 */	Trap, 0,
	/* 3a7 */	Trap, 0,
	/* 3a8 */	Trap, 0,
	/* 3a9 */	Trap, 0,
	/* 3aa */	Trap, 0,
	/* 3ab */	Trap, 0,
	/* 3ac */	Trap, 0,
	/* 3ad */	Trap, 0,
	/* 3ae */	Trap, 0,
	/* 3af */	Trap, 0,
	/* 3b0 */	Trap, 0,
	/* 3b1 */	Trap, 0,
	/* 3b2 */	Trap, 0,
	/* 3b3 */	Trap, 0,
	/* 3b4 */	Trap, 0,
	/* 3b5 */	Trap, 0,
	/* 3b6 */	Trap, 0,
	/* 3b7 */	Trap, 0,
	/* 3b8 */	Trap, 0,
	/* 3b9 */	Trap, 0,
	/* 3ba */	Trap, 0,
	/* 3bb */	Trap, 0,
	/* 3bc */	Trap, 0,
	/* 3bd */	Trap, 0,
	/* 3be */	Trap, 0,
	/* 3bf */	Trap, 0,
	/* 3c0 */	Trap, 0,
	/* 3c1 */	Trap, 0,
	/* 3c2 */	Trap, 0,
	/* 3c3 */	Trap, 0,
	/* 3c4 */	Trap, 0,
	/* 3c5 */	Trap, 0,
	/* 3c6 */	Trap, 0,
	/* 3c7 */	Trap, 0,
	/* 3c8 */	Trap, 0,
	/* 3c9 */	Trap, 0,
	/* 3ca */	Trap, 0,
	/* 3cb */	Trap, 0,
	/* 3cc */	Trap, 0,
	/* 3cd */	Trap, 0,
	/* 3ce */	Trap, 0,
	/* 3cf */	Trap, 0,
	/* 3d0 */	Trap, 0,
	/* 3d1 */	Trap, 0,
	/* 3d2 */	Trap, 0,
	/* 3d3 */	Trap, 0,
	/* 3d4 */	Trap, 0,
	/* 3d5 */	Trap, 0,
	/* 3d6 */	Trap, 0,
	/* 3d7 */	Trap, 0,
	/* 3d8 */	Trap, 0,
	/* 3d9 */	Trap, 0,
	/* 3da */	Trap, 0,
	/* 3db */	Trap, 0,
	/* 3dc */	Trap, 0,
	/* 3dd */	Trap, 0,
	/* 3de */	Trap, 0,
	/* 3df */	Trap, 0,
	/* 3e0 */	Trap, 0,
	/* 3e1 */	Trap, 0,
	/* 3e2 */	Trap, 0,
	/* 3e3 */	Trap, 0,
	/* 3e4 */	Trap, 0,
	/* 3e5 */	Trap, 0,
	/* 3e6 */	Trap, 0,
	/* 3e7 */	Trap, 0,
	/* 3e8 */	Trap, 0,
	/* 3e9 */	Trap, 0,
	/* 3ea */	Trap, 0,
	/* 3eb */	Trap, 0,
	/* 3ec */	Trap, 0,
	/* 3ed */	Trap, 0,
	/* 3ee */	Trap, 0,
	/* 3ef */	Trap, 0,
	/* 3f0 */	Trap, 0,
	/* 3f1 */	Trap, 0,
	/* 3f2 */	Trap, 0,
	/* 3f3 */	Trap, 0,
	/* 3f4 */	Trap, 0,
	/* 3f5 */	Trap, 0,
	/* 3f6 */	Trap, 0,
	/* 3f7 */	Trap, 0,
	/* 3f8 */	Trap, 0,
	/* 3f9 */	Trap, 0,
	/* 3fa */	Trap, 0,
	/* 3fb */	Trap, 0,
	/* 3fc */	Trap, 0,
	/* 3fd */	Trap, 0,
	/* 3fe */	Trap, 0,
	/* 3ff */	Trap, 0,
	/* 400 */	Trap, 0,
	/* 401 */	Trap, 0,
	/* 402 */	Trap, 0,
	/* 403 */	Trap, 0,
	/* 404 */	Trap, 0,
	/* 405 */	Trap, 0,
	/* 406 */	Trap, 0,
	/* 407 */	Trap, 0,
	/* 408 */	Trap, 0,
	/* 409 */	Trap, 0,
	/* 40a */	Trap, 0,
	/* 40b */	Trap, 0,
	/* 40c */	Trap, 0,
	/* 40d */	Trap, 0,
	/* 40e */	Trap, 0,
	/* 40f */	Trap, 0,
	/* 410 */	Trap, 0,
	/* 411 */	Trap, 0,
	/* 412 */	Trap, 0,
	/* 413 */	Trap, 0,
	/* 414 */	Trap, 0,
	/* 415 */	Trap, 0,
	/* 416 */	Trap, 0,
	/* 417 */	Trap, 0,
	/* 418 */	Trap, 0,
	/* 419 */	Trap, 0,
	/* 41a */	Trap, 0,
	/* 41b */	Trap, 0,
	/* 41c */	Trap, 0,
	/* 41d */	Trap, 0,
	/* 41e */	Trap, 0,
	/* 41f */	Trap, 0,
	/* 420 */	Trap, 0,
	/* 421 */	Trap, 0,
	/* 422 */	Trap, 0,
	/* 423 */	Trap, 0,
	/* 424 */	Trap, 0,
	/* 425 */	Trap, 0,
	/* 426 */	Trap, 0,
	/* 427 */	Trap, 0,
	/* 428 */	Trap, 0,
	/* 429 */	Trap, 0,
	/* 42a */	Trap, 0,
	/* 42b */	Trap, 0,
	/* 42c */	Trap, 0,
	/* 42d */	Trap, 0,
	/* 42e */	Trap, 0,
	/* 42f */	Trap, 0,
	/* 430 */	Trap, 0,
	/* 431 */	Trap, 0,
	/* 432 */	Trap, 0,
	/* 433 */	Trap, 0,
	/* 434 */	Trap, 0,
	/* 435 */	Trap, 0,
	/* 436 */	Trap, 0,
	/* 437 */	Trap, 0,
	/* 438 */	Trap, 0,
	/* 439 */	Trap, 0,
	/* 43a */	Trap, 0,
	/* 43b */	Trap, 0,
	/* 43c */	Trap, 0,
	/* 43d */	Trap, 0,
	/* 43e */	Trap, 0,
	/* 43f */	Trap, 0,
	/* 440 */	Trap, 0,
	/* 441 */	Trap, 0,
	/* 442 */	Trap, 0,
	/* 443 */	Trap, 0,
	/* 444 */	Trap, 0,
	/* 445 */	Trap, 0,
	/* 446 */	Trap, 0,
	/* 447 */	Trap, 0,
	/* 448 */	Trap, 0,
	/* 449 */	Trap, 0,
	/* 44a */	Trap, 0,
	/* 44b */	Trap, 0,
	/* 44c */	Trap, 0,
	/* 44d */	Trap, 0,
	/* 44e */	Trap, 0,
	/* 44f */	Trap, 0,
	/* 450 */	Trap, 0,
	/* 451 */	Trap, 0,
	/* 452 */	Trap, 0,
	/* 453 */	Trap, 0,
	/* 454 */	Trap, 0,
	/* 455 */	Trap, 0,
	/* 456 */	Trap, 0,
	/* 457 */	Trap, 0,
	/* 458 */	Trap, 0,
	/* 459 */	Trap, 0,
	/* 45a */	Trap, 0,
	/* 45b */	Trap, 0,
	/* 45c */	Trap, 0,
	/* 45d */	Trap, 0,
	/* 45e */	Trap, 0,
	/* 45f */	Trap, 0,
	/* 460 */	Trap, 0,
	/* 461 */	Trap, 0,
	/* 462 */	Trap, 0,
	/* 463 */	Trap, 0,
	/* 464 */	Trap, 0,
	/* 465 */	Trap, 0,
	/* 466 */	Trap, 0,
	/* 467 */	Trap, 0,
	/* 468 */	Trap, 0,
	/* 469 */	Trap, 0,
	/* 46a */	Trap, 0,
	/* 46b */	Trap, 0,
	/* 46c */	Trap, 0,
	/* 46d */	Trap, 0,
	/* 46e */	Trap, 0,
	/* 46f */	Trap, 0,
	/* 470 */	Trap, 0,
	/* 471 */	Trap, 0,
	/* 472 */	Trap, 0,
	/* 473 */	Trap, 0,
	/* 474 */	Trap, 0,
	/* 475 */	Trap, 0,
	/* 476 */	Trap, 0,
	/* 477 */	Trap, 0,
	/* 478 */	Trap, 0,
	/* 479 */	Trap, 0,
	/* 47a */	Trap, 0,
	/* 47b */	Trap, 0,
	/* 47c */	Trap, 0,
	/* 47d */	Trap, 0,
	/* 47e */	Trap, 0,
	/* 47f */	Trap, 0,
	/* 480 */	Trap, 0,
	/* 481 */	Trap, 0,
	/* 482 */	Trap, 0,
	/* 483 */	Trap, 0,
	/* 484 */	Trap, 0,
	/* 485 */	Trap, 0,
	/* 486 */	Trap, 0,
	/* 487 */	Trap, 0,
	/* 488 */	Trap, 0,
	/* 489 */	Trap, 0,
	/* 48a */	Trap, 0,
	/* 48b */	Trap, 0,
	/* 48c */	Trap, 0,
	/* 48d */	Trap, 0,
	/* 48e */	Trap, 0,
	/* 48f */	Trap, 0,
	/* 490 */	Trap, 0,
	/* 491 */	Trap, 0,
	/* 492 */	Trap, 0,
	/* 493 */	Trap, 0,
	/* 494 */	Trap, 0,
	/* 495 */	Trap, 0,
	/* 496 */	Trap, 0,
	/* 497 */	Trap, 0,
	/* 498 */	Trap, 0,
	/* 499 */	Trap, 0,
	/* 49a */	Trap, 0,
	/* 49b */	Trap, 0,
	/* 49c */	Trap, 0,
	/* 49d */	Trap, 0,
	/* 49e */	Trap, 0,
	/* 49f */	Trap, 0,
	/* 4a0 */	Trap, 0,
	/* 4a1 */	Trap, 0,
	/* 4a2 */	Trap, 0,
	/* 4a3 */	Trap, 0,
	/* 4a4 */	Trap, 0,
	/* 4a5 */	Trap, 0,
	/* 4a6 */	Trap, 0,
	/* 4a7 */	Trap, 0,
	/* 4a8 */	Trap, 0,
	/* 4a9 */	Trap, 0,
	/* 4aa */	Trap, 0,
	/* 4ab */	Trap, 0,
	/* 4ac */	Trap, 0,
	/* 4ad */	Trap, 0,
	/* 4ae */	Trap, 0,
	/* 4af */	Trap, 0,
	/* 4b0 */	Trap, 0,
	/* 4b1 */	Trap, 0,
	/* 4b2 */	Trap, 0,
	/* 4b3 */	Trap, 0,
	/* 4b4 */	Trap, 0,
	/* 4b5 */	Trap, 0,
	/* 4b6 */	Trap, 0,
	/* 4b7 */	Trap, 0,
	/* 4b8 */	Trap, 0,
	/* 4b9 */	Trap, 0,
	/* 4ba */	Trap, 0,
	/* 4bb */	Trap, 0,
	/* 4bc */	Trap, 0,
	/* 4bd */	Trap, 0,
	/* 4be */	Trap, 0,
	/* 4bf */	Trap, 0,
	/* 4c0 */	Trap, 0,
	/* 4c1 */	Trap, 0,
	/* 4c2 */	Trap, 0,
	/* 4c3 */	Trap, 0,
	/* 4c4 */	Trap, 0,
	/* 4c5 */	Trap, 0,
	/* 4c6 */	Trap, 0,
	/* 4c7 */	Trap, 0,
	/* 4c8 */	Trap, 0,
	/* 4c9 */	Trap, 0,
	/* 4ca */	Trap, 0,
	/* end */	0, 0
};
#else
{
	/* nil */	0, 0,
	/* 001 */	Trap, 0,
	/* 002 */	Trap, 0,
	/* 003 */	Trap, 0,
	/* 004 */	Trap, 0,
	/* 005 */	Trap, 0,
	/* 006 */	Trap, 0,
	/* 007 */	Trap, 0,
	/* 008 */	Trap, 0,
	/* 009 */	Trap, 0,
	/* 00a */	Trap, 0,
	/* 00b */	Trap, 0,
	/* 00c */	Trap, 0,
	/* 00d */	Trap, 0,
	/* 00e */	Trap, 0,
	/* 00f */	Trap, 0,
	/* 010 */	Trap, 0,
	/* 011 */	Trap, 0,
	/* 012 */	Trap, 0,
	/* 013 */	Trap, 0,
	/* 014 */	Trap, 0,
	/* 015 */	Trap, 0,
	/* 016 */	Trap, 0,
	/* 017 */	Trap, 0,
	/* 018 */	Trap, 0,
	/* 019 */	Trap, 0,
	/* 01a */	Trap, 0,
	/* 01b */	Trap, 0,
	/* 01c */	Trap, 0,
	/* 01d */	Trap, 0,
	/* 01e */	Trap, 0,
	/* 01f */	Trap, 0,
	/* 020 */	Trap, 0,
	/* 021 */	Trap, 0,
	/* 022 */	Trap, 0,
	/* 023 */	Trap, 0,
	/* 024 */	Trap, 0,
	/* 025 */	Trap, 0,
	/* 026 */	Trap, 0,
	/* 027 */	Trap, 0,
	/* 028 */	Trap, 0,
	/* 029 */	Trap, 0,
	/* 02a */	Trap, 0,
	/* 02b */	Trap, 0,
	/* 02c */	Trap, 0,
	/* 02d */	Trap, 0,
	/* 02e */	Trap, 0,
	/* 02f */	Trap, 0,
	/* 030 */	Trap, 0,
	/* 031 */	Trap, 0,
	/* 032 */	Trap, 0,
	/* 033 */	Trap, 0,
	/* 034 */	Trap, 0,
	/* 035 */	Trap, 0,
	/* 036 */	Trap, 0,
	/* 037 */	Trap, 0,
	/* 038 */	Trap, 0,
	/* 039 */	Trap, 0,
	/* 03a */	Trap, 0,
	/* 03b */	Trap, 0,
	/* 03c */	Trap, 0,
	/* 03d */	Trap, 0,
	/* 03e */	Trap, 0,
	/* 03f */	Trap, 0,
	/* 040 */	Trap, 0,
	/* 041 */	Trap, 0,
	/* 042 */	Trap, 0,
	/* 043 */	Trap, 0,
	/* 044 */	Trap, 0,
	/* 045 */	Trap, 0,
	/* 046 */	Trap, 0,
	/* 047 */	Trap, 0,
	/* 048 */	Trap, 0,
	/* 049 */	Trap, 0,
	/* 04a */	Trap, 0,
	/* 04b */	Trap, 0,
	/* 04c */	Trap, 0,
	/* 04d */	Trap, 0,
	/* 04e */	Trap, 0,
	/* 04f */	Trap, 0,
	/* 050 */	Trap, 0,
	/* 051 */	Trap, 0,
	/* 052 */	Trap, 0,
	/* 053 */	Trap, 0,
	/* 054 */	Trap, 0,
	/* 055 */	Trap, 0,
	/* 056 */	Trap, 0,
	/* 057 */	Trap, 0,
	/* 058 */	Trap, 0,
	/* 059 */	Trap, 0,
	/* 05a */	Trap, 0,
	/* 05b */	Trap, 0,
	/* 05c */	Trap, 0,
	/* 05d */	Trap, 0,
	/* 05e */	Trap, 0,
	/* 05f */	Trap, 0,
	/* 060 */	Trap, 0,
	/* 061 */	Trap, 0,
	/* 062 */	Trap, 0,
	/* 063 */	Trap, 0,
	/* 064 */	Trap, 0,
	/* 065 */	Trap, 0,
	/* 066 */	Trap, 0,
	/* 067 */	Trap, 0,
	/* 068 */	Trap, 0,
	/* 069 */	Trap, 0,
	/* 06a */	Trap, 0,
	/* 06b */	Trap, 0,
	/* 06c */	Trap, 0,
	/* 06d */	Trap, 0,
	/* 06e */	Trap, 0,
	/* 06f */	Trap, 0,
	/* 070 */	Trap, 0,
	/* 071 */	Trap, 0,
	/* 072 */	Trap, 0,
	/* 073 */	Trap, 0,
	/* 074 */	Trap, 0,
	/* 075 */	Trap, 0,
	/* 076 */	Trap, 0,
	/* 077 */	Trap, 0,
	/* 078 */	Trap, 0,
	/* 079 */	Trap, 0,
	/* 07a */	Trap, 0,
	/* 07b */	Trap, 0,
	/* 07c */	Trap, 0,
	/* 07d */	Trap, 0,
	/* 07e */	Trap, 0,
	/* 07f */	Trap, 0,
	/* 080 */	Trap, 0,
	/* 081 */	Trap, 0,
	/* 082 */	Trap, 0,
	/* 083 */	Trap, 0,
	/* 084 */	Trap, 0,
	/* 085 */	Trap, 0,
	/* 086 */	Trap, 0,
	/* 087 */	Trap, 0,
	/* 088 */	Trap, 0,
	/* 089 */	Trap, 0,
	/* 08a */	Trap, 0,
	/* 08b */	Trap, 0,
	/* 08c */	Trap, 0,
	/* 08d */	Trap, 0,
	/* 08e */	Trap, 0,
	/* 08f */	Trap, 0,
	/* 090 */	Trap, 0,
	/* 091 */	Trap, 0,
	/* 092 */	Trap, 0,
	/* 093 */	Trap, 0,
	/* 094 */	Trap, 0,
	/* 095 */	Trap, 0,
	/* 096 */	Trap, 0,
	/* 097 */	Trap, 0,
	/* 098 */	Trap, 0,
	/* 099 */	Trap, 0,
	/* 09a */	Trap, 0,
	/* 09b */	Trap, 0,
	/* 09c */	Trap, 0,
	/* 09d */	Trap, 0,
	/* 09e */	Trap, 0,
	/* 09f */	Trap, 0,
	/* 0a0 */	Trap, 0,
	/* 0a1 */	Trap, 0,
	/* 0a2 */	Trap, 0,
	/* 0a3 */	Trap, 0,
	/* 0a4 */	Trap, 0,
	/* 0a5 */	Trap, 0,
	/* 0a6 */	Trap, 0,
	/* 0a7 */	Trap, 0,
	/* 0a8 */	Trap, 0,
	/* 0a9 */	Trap, 0,
	/* 0aa */	Trap, 0,
	/* 0ab */	Trap, 0,
	/* 0ac */	Trap, 0,
	/* 0ad */	Trap, 0,
	/* 0ae */	Trap, 0,
	/* 0af */	Trap, 0,
	/* 0b0 */	Trap, 0,
	/* 0b1 */	Trap, 0,
	/* 0b2 */	Trap, 0,
	/* 0b3 */	Trap, 0,
	/* 0b4 */	Trap, 0,
	/* 0b5 */	Trap, 0,
	/* 0b6 */	Trap, 0,
	/* 0b7 */	Trap, 0,
	/* 0b8 */	Trap, 0,
	/* 0b9 */	Trap, 0,
	/* 0ba */	Trap, 0,
	/* 0bb */	Trap, 0,
	/* 0bc */	Trap, 0,
	/* 0bd */	Trap, 0,
	/* 0be */	Trap, 0,
	/* 0bf */	Trap, 0,
	/* 0c0 */	Trap, 0,
	/* 0c1 */	Trap, 0,
	/* 0c2 */	Trap, 0,
	/* 0c3 */	Trap, 0,
	/* 0c4 */	Trap, 0,
	/* 0c5 */	Trap, 0,
	/* 0c6 */	Trap, 0,
	/* 0c7 */	Trap, 0,
	/* 0c8 */	Trap, 0,
	/* 0c9 */	Trap, 0,
	/* 0ca */	Trap, 0,
	/* 0cb */	Trap, 0,
	/* 0cc */	Trap, 0,
	/* 0cd */	Trap, 0,
	/* 0ce */	Trap, 0,
	/* 0cf */	Trap, 0,
	/* 0d0 */	Trap, 0,
	/* 0d1 */	Trap, 0,
	/* 0d2 */	Trap, 0,
	/* 0d3 */	Trap, 0,
	/* 0d4 */	Trap, 0,
	/* 0d5 */	Trap, 0,
	/* 0d6 */	Trap, 0,
	/* 0d7 */	Trap, 0,
	/* 0d8 */	Trap, 0,
	/* 0d9 */	Trap, 0,
	/* 0da */	Trap, 0,
	/* 0db */	Trap, 0,
	/* 0dc */	Trap, 0,
	/* 0dd */	Trap, 0,
	/* 0de */	Trap, 0,
	/* 0df */	Trap, 0,
	/* 0e0 */	Trap, 0,
	/* 0e1 */	Trap, 0,
	/* 0e2 */	Trap, 0,
	/* 0e3 */	Trap, 0,
	/* 0e4 */	Trap, 0,
	/* 0e5 */	Trap, 0,
	/* 0e6 */	Trap, 0,
	/* 0e7 */	Trap, 0,
	/* 0e8 */	Trap, 0,
	/* 0e9 */	Trap, 0,
	/* 0ea */	Trap, 0,
	/* 0eb */	Trap, 0,
	/* 0ec */	Trap, 0,
	/* 0ed */	Trap, 0,
	/* 0ee */	Trap, 0,
	/* 0ef */	Trap, 0,
	/* 0f0 */	Trap, 0,
	/* 0f1 */	Trap, 0,
	/* 0f2 */	Trap, 0,
	/* 0f3 */	Trap, 0,
	/* 0f4 */	Trap, 0,
	/* 0f5 */	Trap, 0,
	/* 0f6 */	Trap, 0,
	/* 0f7 */	Trap, 0,
	/* 0f8 */	Trap, 0,
	/* 0f9 */	Trap, 0,
	/* 0fa */	Trap, 0,
	/* 0fb */	Trap, 0,
	/* 0fc */	Trap, 0,
	/* 0fd */	Trap, 0,
	/* 0fe */	Trap, 0,
	/* 0ff */	Trap, 0,
	/* 100 */	Trap, 0,
	/* 101 */	Trap, 0,
	/* 102 */	Trap, 0,
	/* 103 */	Trap, 0,
	/* 104 */	Trap, 0,
	/* 105 */	Trap, 0,
	/* 106 */	Trap, 0,
	/* 107 */	Trap, 0,
	/* 108 */	Trap, 0,
	/* 109 */	Trap, 0,
	/* 10a */	Trap, 0,
	/* 10b */	Trap, 0,
	/* 10c */	Trap, 0,
	/* 10d */	Trap, 0,
	/* 10e */	Trap, 0,
	/* 10f */	Trap, 0,
	/* 110 */	Trap, 0,
	/* 111 */	Trap, 0,
	/* 112 */	Trap, 0,
	/* 113 */	Trap, 0,
	/* 114 */	Trap, 0,
	/* 115 */	Trap, 0,
	/* 116 */	Trap, 0,
	/* 117 */	Trap, 0,
	/* 118 */	Trap, 0,
	/* 119 */	Trap, 0,
	/* 11a */	Trap, 0,
	/* 11b */	Trap, 0,
	/* 11c */	Trap, 0,
	/* 11d */	Trap, 0,
	/* 11e */	Trap, 0,
	/* 11f */	Trap, 0,
	/* 120 */	Trap, 0,
	/* 121 */	Trap, 0,
	/* 122 */	Trap, 0,
	/* 123 */	Trap, 0,
	/* 124 */	Trap, 0,
	/* 125 */	Trap, 0,
	/* 126 */	Trap, 0,
	/* 127 */	Trap, 0,
	/* 128 */	Trap, 0,
	/* 129 */	Trap, 0,
	/* 12a */	Trap, 0,
	/* 12b */	Trap, 0,
	/* 12c */	Trap, 0,
	/* 12d */	Trap, 0,
	/* 12e */	Trap, 0,
	/* 12f */	Trap, 0,
	/* 130 */	Trap, 0,
	/* 131 */	Trap, 0,
	/* 132 */	Trap, 0,
	/* 133 */	Trap, 0,
	/* 134 */	Trap, 0,
	/* 135 */	Trap, 0,
	/* 136 */	Trap, 0,
	/* 137 */	Trap, 0,
	/* 138 */	Trap, 0,
	/* 139 */	Trap, 0,
	/* 13a */	Trap, 0,
	/* 13b */	Trap, 0,
	/* 13c */	Trap, 0,
	/* 13d */	Trap, 0,
	/* 13e */	Trap, 0,
	/* 13f */	Trap, 0,
	/* 140 */	Trap, 0,
	/* 141 */	Trap, 0,
	/* 142 */	Trap, 0,
	/* 143 */	Trap, 0,
	/* 144 */	Trap, 0,
	/* 145 */	Trap, 0,
	/* 146 */	Trap, 0,
	/* 147 */	Trap, 0,
	/* 148 */	Trap, 0,
	/* 149 */	Trap, 0,
	/* 14a */	Trap, 0,
	/* 14b */	Trap, 0,
	/* 14c */	Trap, 0,
	/* 14d */	Trap, 0,
	/* 14e */	Trap, 0,
	/* 14f */	Trap, 0,
	/* 150 */	Trap, 0,
	/* 151 */	Trap, 0,
	/* 152 */	Trap, 0,
	/* 153 */	Trap, 0,
	/* 154 */	Trap, 0,
	/* 155 */	Trap, 0,
	/* 156 */	Trap, 0,
	/* 157 */	Trap, 0,
	/* 158 */	Trap, 0,
	/* 159 */	Trap, 0,
	/* 15a */	Trap, 0,
	/* 15b */	Trap, 0,
	/* 15c */	Trap, 0,
	/* 15d */	Trap, 0,
	/* 15e */	Trap, 0,
	/* 15f */	Trap, 0,
	/* 160 */	Trap, 0,
	/* 161 */	Trap, 0,
	/* 162 */	Trap, 0,
	/* 163 */	Trap, 0,
	/* 164 */	Trap, 0,
	/* 165 */	Trap, 0,
	/* 166 */	Trap, 0,
	/* 167 */	Trap, 0,
	/* 168 */	Trap, 0,
	/* 169 */	Trap, 0,
	/* 16a */	Trap, 0,
	/* 16b */	Trap, 0,
	/* 16c */	Trap, 0,
	/* 16d */	Trap, 0,
	/* 16e */	Trap, 0,
	/* 16f */	Trap, 0,
	/* 170 */	Trap, 0,
	/* 171 */	Trap, 0,
	/* 172 */	Trap, 0,
	/* 173 */	Trap, 0,
	/* 174 */	Trap, 0,
	/* 175 */	Trap, 0,
	/* 176 */	Trap, 0,
	/* 177 */	Trap, 0,
	/* 178 */	Trap, 0,
	/* 179 */	Trap, 0,
	/* 17a */	Trap, 0,
	/* 17b */	Trap, 0,
	/* 17c */	Trap, 0,
	/* 17d */	Trap, 0,
	/* 17e */	Trap, 0,
	/* 17f */	Trap, 0,
	/* 180 */	Trap, 0,
	/* 181 */	Trap, 0,
	/* 182 */	Trap, 0,
	/* 183 */	Trap, 0,
	/* 184 */	Trap, 0,
	/* 185 */	Trap, 0,
	/* 186 */	Trap, 0,
	/* 187 */	Trap, 0,
	/* 188 */	Trap, 0,
	/* 189 */	Trap, 0,
	/* 18a */	Trap, 0,
	/* 18b */	Trap, 0,
	/* 18c */	Trap, 0,
	/* 18d */	Trap, 0,
	/* 18e */	Trap, 0,
	/* 18f */	Trap, 0,
	/* 190 */	Trap, 0,
	/* 191 */	Trap, 0,
	/* 192 */	Trap, 0,
	/* 193 */	Trap, 0,
	/* 194 */	Trap, 0,
	/* 195 */	Trap, 0,
	/* 196 */	Trap, 0,
	/* 197 */	Trap, 0,
	/* 198 */	Trap, 0,
	/* 199 */	Trap, 0,
	/* 19a */	Trap, 0,
	/* 19b */	Trap, 0,
	/* 19c */	Trap, 0,
	/* 19d */	Trap, 0,
	/* 19e */	Trap, 0,
	/* 19f */	Trap, 0,
	/* 1a0 */	Trap, 0,
	/* 1a1 */	Trap, 0,
	/* 1a2 */	Trap, 0,
	/* 1a3 */	Trap, 0,
	/* 1a4 */	Trap, 0,
	/* 1a5 */	Trap, 0,
	/* 1a6 */	Trap, 0,
	/* 1a7 */	Trap, 0,
	/* 1a8 */	Trap, 0,
	/* 1a9 */	Trap, 0,
	/* 1aa */	Trap, 0,
	/* 1ab */	Trap, 0,
	/* 1ac */	Trap, 0,
	/* 1ad */	Trap, 0,
	/* 1ae */	Trap, 0,
	/* 1af */	Trap, 0,
	/* 1b0 */	Trap, 0,
	/* 1b1 */	Trap, 0,
	/* 1b2 */	Trap, 0,
	/* 1b3 */	Trap, 0,
	/* 1b4 */	Trap, 0,
	/* 1b5 */	Trap, 0,
	/* 1b6 */	Trap, 0,
	/* 1b7 */	Trap, 0,
	/* 1b8 */	Trap, 0,
	/* 1b9 */	Trap, 0,
	/* 1ba */	Trap, 0,
	/* 1bb */	Trap, 0,
	/* 1bc */	Trap, 0,
	/* 1bd */	Trap, 0,
	/* 1be */	Trap, 0,
	/* 1bf */	Trap, 0,
	/* 1c0 */	Trap, 0,
	/* 1c1 */	Trap, 0,
	/* 1c2 */	Trap, 0,
	/* 1c3 */	Trap, 0,
	/* 1c4 */	Trap, 0,
	/* 1c5 */	Trap, 0,
	/* 1c6 */	Trap, 0,
	/* 1c7 */	Trap, 0,
	/* 1c8 */	Trap, 0,
	/* 1c9 */	Trap, 0,
	/* 1ca */	Trap, 0,
	/* 1cb */	Trap, 0,
	/* 1cc */	Trap, 0,
	/* 1cd */	Trap, 0,
	/* 1ce */	Trap, 0,
	/* 1cf */	Trap, 0,
	/* 1d0 */	Trap, 0,
	/* 1d1 */	Trap, 0,
	/* 1d2 */	Trap, 0,
	/* 1d3 */	Trap, 0,
	/* 1d4 */	Trap, 0,
	/* 1d5 */	Trap, 0,
	/* 1d6 */	Trap, 0,
	/* 1d7 */	Trap, 0,
	/* 1d8 */	Trap, 0,
	/* 1d9 */	Trap, 0,
	/* 1da */	Trap, 0,
	/* 1db */	Trap, 0,
	/* 1dc */	Trap, 0,
	/* 1dd */	Trap, 0,
	/* 1de */	Trap, 0,
	/* 1df */	Trap, 0,
	/* 1e0 */	Trap, 0,
	/* 1e1 */	Trap, 0,
	/* 1e2 */	Trap, 0,
	/* 1e3 */	Trap, 0,
	/* 1e4 */	Trap, 0,
	/* 1e5 */	Trap, 0,
	/* 1e6 */	Trap, 0,
	/* 1e7 */	Trap, 0,
	/* 1e8 */	Trap, 0,
	/* 1e9 */	Trap, 0,
	/* 1ea */	Trap, 0,
	/* 1eb */	Trap, 0,
	/* 1ec */	Trap, 0,
	/* 1ed */	Trap, 0,
	/* 1ee */	Trap, 0,
	/* 1ef */	Trap, 0,
	/* 1f0 */	Trap, 0,
	/* 1f1 */	Trap, 0,
	/* 1f2 */	Trap, 0,
	/* 1f3 */	Trap, 0,
	/* 1f4 */	Trap, 0,
	/* 1f5 */	Trap, 0,
	/* 1f6 */	Trap, 0,
	/* 1f7 */	Trap, 0,
	/* 1f8 */	Trap, 0,
	/* 1f9 */	Trap, 0,
	/* 1fa */	Trap, 0,
	/* 1fb */	Trap, 0,
	/* 1fc */	Trap, 0,
	/* 1fd */	Trap, 0,
	/* 1fe */	Trap, 0,
	/* 1ff */	Trap, 0,
	/* 200 */	Trap, 0,
	/* 201 */	Trap, 0,
	/* 202 */	Trap, 0,
	/* 203 */	Trap, 0,
	/* 204 */	Trap, 0,
	/* 205 */	Trap, 0,
	/* 206 */	Trap, 0,
	/* 207 */	Trap, 0,
	/* 208 */	Trap, 0,
	/* 209 */	Trap, 0,
	/* 20a */	Trap, 0,
	/* 20b */	Trap, 0,
	/* 20c */	Trap, 0,
	/* 20d */	Trap, 0,
	/* 20e */	Trap, 0,
	/* 20f */	Trap, 0,
	/* 210 */	Trap, 0,
	/* 211 */	Trap, 0,
	/* 212 */	Trap, 0,
	/* 213 */	Trap, 0,
	/* 214 */	Trap, 0,
	/* 215 */	Trap, 0,
	/* 216 */	Trap, 0,
	/* 217 */	Trap, 0,
	/* 218 */	Trap, 0,
	/* 219 */	Trap, 0,
	/* 21a */	Trap, 0,
	/* 21b */	Trap, 0,
	/* 21c */	Trap, 0,
	/* 21d */	Trap, 0,
	/* 21e */	Trap, 0,
	/* 21f */	Trap, 0,
	/* 220 */	Trap, 0,
	/* 221 */	Trap, 0,
	/* 222 */	Trap, 0,
	/* 223 */	Trap, 0,
	/* 224 */	Trap, 0,
	/* 225 */	Trap, 0,
	/* 226 */	Trap, 0,
	/* 227 */	Trap, 0,
	/* 228 */	Trap, 0,
	/* 229 */	Trap, 0,
	/* 22a */	Trap, 0,
	/* 22b */	Trap, 0,
	/* 22c */	Trap, 0,
	/* 22d */	Trap, 0,
	/* 22e */	Trap, 0,
	/* 22f */	Trap, 0,
	/* 230 */	Trap, 0,
	/* 231 */	Trap, 0,
	/* 232 */	Trap, 0,
	/* 233 */	Trap, 0,
	/* 234 */	Trap, 0,
	/* 235 */	Trap, 0,
	/* 236 */	Trap, 0,
	/* 237 */	Trap, 0,
	/* 238 */	Trap, 0,
	/* 239 */	Trap, 0,
	/* 23a */	Trap, 0,
	/* 23b */	Trap, 0,
	/* 23c */	Trap, 0,
	/* 23d */	Trap, 0,
	/* 23e */	Trap, 0,
	/* 23f */	Trap, 0,
	/* 240 */	Trap, 0,
	/* 241 */	Trap, 0,
	/* 242 */	Trap, 0,
	/* 243 */	Trap, 0,
	/* 244 */	Trap, 0,
	/* 245 */	Trap, 0,
	/* 246 */	Trap, 0,
	/* 247 */	Trap, 0,
	/* 248 */	Trap, 0,
	/* 249 */	Trap, 0,
	/* 24a */	Trap, 0,
	/* 24b */	Trap, 0,
	/* 24c */	Trap, 0,
	/* 24d */	Trap, 0,
	/* 24e */	Trap, 0,
	/* 24f */	Trap, 0,
	/* 250 */	Trap, 0,
	/* 251 */	Trap, 0,
	/* 252 */	Trap, 0,
	/* 253 */	Trap, 0,
	/* 254 */	Trap, 0,
	/* 255 */	Trap, 0,
	/* 256 */	Trap, 0,
	/* 257 */	Trap, 0,
	/* 258 */	Trap, 0,
	/* 259 */	Trap, 0,
	/* 25a */	Trap, 0,
	/* 25b */	Trap, 0,
	/* 25c */	Trap, 0,
	/* 25d */	Trap, 0,
	/* 25e */	Trap, 0,
	/* 25f */	Trap, 0,
	/* 260 */	Trap, 0,
	/* 261 */	Trap, 0,
	/* 262 */	Trap, 0,
	/* 263 */	Trap, 0,
	/* 264 */	Trap, 0,
	/* 265 */	Trap, 0,
	/* 266 */	Trap, 0,
	/* 267 */	Trap, 0,
	/* 268 */	Trap, 0,
	/* 269 */	Trap, 0,
	/* 26a */	Trap, 0,
	/* 26b */	Trap, 0,
	/* 26c */	Trap, 0,
	/* 26d */	Trap, 0,
	/* 26e */	Trap, 0,
	/* 26f */	Trap, 0,
	/* 270 */	Trap, 0,
	/* 271 */	Trap, 0,
	/* 272 */	Trap, 0,
	/* 273 */	Trap, 0,
	/* 274 */	Trap, 0,
	/* 275 */	Trap, 0,
	/* 276 */	Trap, 0,
	/* 277 */	Trap, 0,
	/* 278 */	Trap, 0,
	/* 279 */	Trap, 0,
	/* 27a */	Trap, 0,
	/* 27b */	Trap, 0,
	/* 27c */	Trap, 0,
	/* 27d */	Trap, 0,
	/* 27e */	Trap, 0,
	/* 27f */	Trap, 0,
	/* 280 */	Trap, 0,
	/* 281 */	Trap, 0,
	/* 282 */	Trap, 0,
	/* 283 */	Trap, 0,
	/* 284 */	Trap, 0,
	/* 285 */	Trap, 0,
	/* 286 */	Trap, 0,
	/* 287 */	Trap, 0,
	/* 288 */	Trap, 0,
	/* 289 */	Trap, 0,
	/* 28a */	Trap, 0,
	/* 28b */	Trap, 0,
	/* 28c */	Trap, 0,
	/* 28d */	Trap, 0,
	/* 28e */	Trap, 0,
	/* 28f */	Trap, 0,
	/* 290 */	Trap, 0,
	/* 291 */	Trap, 0,
	/* 292 */	Trap, 0,
	/* 293 */	Trap, 0,
	/* 294 */	Trap, 0,
	/* 295 */	Trap, 0,
	/* 296 */	Trap, 0,
	/* 297 */	Trap, 0,
	/* 298 */	Trap, 0,
	/* 299 */	Trap, 0,
	/* 29a */	Trap, 0,
	/* 29b */	Trap, 0,
	/* 29c */	Trap, 0,
	/* 29d */	Trap, 0,
	/* 29e */	Trap, 0,
	/* 29f */	Trap, 0,
	/* 2a0 */	Trap, 0,
	/* 2a1 */	Trap, 0,
	/* 2a2 */	Trap, 0,
	/* 2a3 */	Trap, 0,
	/* 2a4 */	Trap, 0,
	/* 2a5 */	Trap, 0,
	/* 2a6 */	Trap, 0,
	/* 2a7 */	Trap, 0,
	/* 2a8 */	Trap, 0,
	/* 2a9 */	Trap, 0,
	/* 2aa */	Trap, 0,
	/* 2ab */	Trap, 0,
	/* 2ac */	Trap, 0,
	/* 2ad */	Trap, 0,
	/* 2ae */	Trap, 0,
	/* 2af */	Trap, 0,
	/* 2b0 */	Trap, 0,
	/* 2b1 */	Trap, 0,
	/* 2b2 */	Trap, 0,
	/* 2b3 */	Trap, 0,
	/* 2b4 */	Trap, 0,
	/* 2b5 */	Trap, 0,
	/* 2b6 */	Trap, 0,
	/* 2b7 */	Trap, 0,
	/* 2b8 */	Trap, 0,
	/* 2b9 */	Trap, 0,
	/* 2ba */	Trap, 0,
	/* 2bb */	Trap, 0,
	/* 2bc */	Trap, 0,
	/* 2bd */	Trap, 0,
	/* 2be */	Trap, 0,
	/* 2bf */	Trap, 0,
	/* 2c0 */	Trap, 0,
	/* 2c1 */	Trap, 0,
	/* 2c2 */	Trap, 0,
	/* 2c3 */	Trap, 0,
	/* 2c4 */	Trap, 0,
	/* 2c5 */	Trap, 0,
	/* 2c6 */	Trap, 0,
	/* 2c7 */	Trap, 0,
	/* 2c8 */	Trap, 0,
	/* 2c9 */	Trap, 0,
	/* 2ca */	Trap, 0,
	/* 2cb */	Trap, 0,
	/* 2cc */	Trap, 0,
	/* 2cd */	Trap, 0,
	/* 2ce */	Trap, 0,
	/* 2cf */	Trap, 0,
	/* 2d0 */	Trap, 0,
	/* 2d1 */	Trap, 0,
	/* 2d2 */	Trap, 0,
	/* 2d3 */	Trap, 0,
	/* 2d4 */	Trap, 0,
	/* 2d5 */	Trap, 0,
	/* 2d6 */	Trap, 0,
	/* 2d7 */	Trap, 0,
	/* 2d8 */	Trap, 0,
	/* 2d9 */	Trap, 0,
	/* 2da */	Trap, 0,
	/* 2db */	Trap, 0,
	/* 2dc */	Trap, 0,
	/* 2dd */	Trap, 0,
	/* 2de */	Trap, 0,
	/* 2df */	Trap, 0,
	/* 2e0 */	Trap, 0,
	/* 2e1 */	Trap, 0,
	/* 2e2 */	Trap, 0,
	/* 2e3 */	Trap, 0,
	/* 2e4 */	Trap, 0,
	/* 2e5 */	Trap, 0,
	/* 2e6 */	Trap, 0,
	/* 2e7 */	Trap, 0,
	/* 2e8 */	Trap, 0,
	/* 2e9 */	Trap, 0,
	/* 2ea */	Trap, 0,
	/* 2eb */	Trap, 0,
	/* 2ec */	Trap, 0,
	/* 2ed */	Trap, 0,
	/* 2ee */	Trap, 0,
	/* 2ef */	Trap, 0,
	/* 2f0 */	Trap, 0,
	/* 2f1 */	Trap, 0,
	/* 2f2 */	Trap, 0,
	/* 2f3 */	Trap, 0,
	/* 2f4 */	Trap, 0,
	/* 2f5 */	Trap, 0,
	/* 2f6 */	Trap, 0,
	/* 2f7 */	Trap, 0,
	/* 2f8 */	Trap, 0,
	/* 2f9 */	Trap, 0,
	/* 2fa */	Trap, 0,
	/* 2fb */	Trap, 0,
	/* 2fc */	Trap, 0,
	/* 2fd */	Trap, 0,
	/* 2fe */	Trap, 0,
	/* 2ff */	Trap, 0,
	/* 300 */	Trap, 0,
	/* 301 */	Trap, 0,
	/* 302 */	Trap, 0,
	/* 303 */	Trap, 0,
	/* 304 */	Trap, 0,
	/* 305 */	Trap, 0,
	/* 306 */	Trap, 0,
	/* 307 */	Trap, 0,
	/* 308 */	Trap, 0,
	/* 309 */	Trap, 0,
	/* 30a */	Trap, 0,
	/* 30b */	Trap, 0,
	/* 30c */	Trap, 0,
	/* 30d */	Trap, 0,
	/* 30e */	Trap, 0,
	/* 30f */	Trap, 0,
	/* 310 */	Trap, 0,
	/* 311 */	Trap, 0,
	/* 312 */	Trap, 0,
	/* 313 */	Trap, 0,
	/* 314 */	Trap, 0,
	/* 315 */	Trap, 0,
	/* 316 */	Trap, 0,
	/* 317 */	Trap, 0,
	/* 318 */	Trap, 0,
	/* 319 */	Trap, 0,
	/* 31a */	Trap, 0,
	/* 31b */	Trap, 0,
	/* 31c */	Trap, 0,
	/* 31d */	Trap, 0,
	/* 31e */	Trap, 0,
	/* 31f */	Trap, 0,
	/* 320 */	Trap, 0,
	/* 321 */	Trap, 0,
	/* 322 */	Trap, 0,
	/* 323 */	Trap, 0,
	/* 324 */	Trap, 0,
	/* 325 */	Trap, 0,
	/* 326 */	Trap, 0,
	/* 327 */	Trap, 0,
	/* 328 */	Trap, 0,
	/* 329 */	Trap, 0,
	/* 32a */	Trap, 0,
	/* 32b */	Trap, 0,
	/* 32c */	Trap, 0,
	/* 32d */	Trap, 0,
	/* 32e */	Trap, 0,
	/* 32f */	Trap, 0,
	/* 330 */	Trap, 0,
	/* 331 */	Trap, 0,
	/* 332 */	Trap, 0,
	/* 333 */	Trap, 0,
	/* 334 */	Trap, 0,
	/* 335 */	Trap, 0,
	/* 336 */	Trap, 0,
	/* 337 */	Trap, 0,
	/* 338 */	Trap, 0,
	/* 339 */	Trap, 0,
	/* 33a */	Trap, 0,
	/* 33b */	Trap, 0,
	/* 33c */	Trap, 0,
	/* 33d */	Trap, 0,
	/* 33e */	Trap, 0,
	/* 33f */	Trap, 0,
	/* 340 */	Trap, 0,
	/* 341 */	Trap, 0,
	/* 342 */	Trap, 0,
	/* 343 */	Trap, 0,
	/* 344 */	Trap, 0,
	/* 345 */	Trap, 0,
	/* 346 */	Trap, 0,
	/* 347 */	Trap, 0,
	/* 348 */	Trap, 0,
	/* 349 */	Trap, 0,
	/* 34a */	Trap, 0,
	/* 34b */	Trap, 0,
	/* 34c */	Trap, 0,
	/* 34d */	Trap, 0,
	/* 34e */	Trap, 0,
	/* 34f */	Trap, 0,
	/* 350 */	Trap, 0,
	/* 351 */	Trap, 0,
	/* 352 */	Trap, 0,
	/* 353 */	Trap, 0,
	/* 354 */	Trap, 0,
	/* 355 */	Trap, 0,
	/* 356 */	Trap, 0,
	/* 357 */	Trap, 0,
	/* 358 */	Trap, 0,
	/* 359 */	Trap, 0,
	/* 35a */	Trap, 0,
	/* 35b */	Trap, 0,
	/* 35c */	Trap, 0,
	/* 35d */	Trap, 0,
	/* 35e */	Trap, 0,
	/* 35f */	Trap, 0,
	/* 360 */	Trap, 0,
	/* 361 */	Trap, 0,
	/* 362 */	Trap, 0,
	/* 363 */	Trap, 0,
	/* 364 */	Trap, 0,
	/* 365 */	Trap, 0,
	/* 366 */	Trap, 0,
	/* 367 */	Trap, 0,
	/* 368 */	Trap, 0,
	/* 369 */	Trap, 0,
	/* 36a */	Trap, 0,
	/* 36b */	Trap, 0,
	/* 36c */	Trap, 0,
	/* 36d */	Trap, 0,
	/* 36e */	Trap, 0,
	/* 36f */	Trap, 0,
	/* 370 */	Trap, 0,
	/* 371 */	Trap, 0,
	/* 372 */	Trap, 0,
	/* 373 */	Trap, 0,
	/* 374 */	Trap, 0,
	/* 375 */	Trap, 0,
	/* 376 */	Trap, 0,
	/* 377 */	Trap, 0,
	/* 378 */	Trap, 0,
	/* 379 */	Trap, 0,
	/* 37a */	Trap, 0,
	/* 37b */	Trap, 0,
	/* 37c */	Trap, 0,
	/* 37d */	Trap, 0,
	/* 37e */	Trap, 0,
	/* 37f */	Trap, 0,
	/* 380 */	Trap, 0,
	/* 381 */	Trap, 0,
	/* 382 */	Trap, 0,
	/* 383 */	Trap, 0,
	/* 384 */	Trap, 0,
	/* 385 */	Trap, 0,
	/* 386 */	Trap, 0,
	/* 387 */	Trap, 0,
	/* 388 */	Trap, 0,
	/* 389 */	Trap, 0,
	/* 38a */	Trap, 0,
	/* 38b */	Trap, 0,
	/* 38c */	Trap, 0,
	/* 38d */	Trap, 0,
	/* 38e */	Trap, 0,
	/* 38f */	Trap, 0,
	/* 390 */	Trap, 0,
	/* 391 */	Trap, 0,
	/* 392 */	Trap, 0,
	/* 393 */	Trap, 0,
	/* 394 */	Trap, 0,
	/* 395 */	Trap, 0,
	/* 396 */	Trap, 0,
	/* 397 */	Trap, 0,
	/* 398 */	Trap, 0,
	/* 399 */	Trap, 0,
	/* 39a */	Trap, 0,
	/* 39b */	Trap, 0,
	/* 39c */	Trap, 0,
	/* 39d */	Trap, 0,
	/* 39e */	Trap, 0,
	/* 39f */	Trap, 0,
	/* 3a0 */	Trap, 0,
	/* 3a1 */	Trap, 0,
	/* 3a2 */	Trap, 0,
	/* 3a3 */	Trap, 0,
	/* 3a4 */	Trap, 0,
	/* 3a5 */	Trap, 0,
	/* 3a6 */	Trap, 0,
	/* 3a7 */	Trap, 0,
	/* 3a8 */	Trap, 0,
	/* 3a9 */	Trap, 0,
	/* 3aa */	Trap, 0,
	/* 3ab */	Trap, 0,
	/* 3ac */	Trap, 0,
	/* 3ad */	Trap, 0,
	/* 3ae */	Trap, 0,
	/* 3af */	Trap, 0,
	/* 3b0 */	Trap, 0,
	/* 3b1 */	Trap, 0,
	/* 3b2 */	Trap, 0,
	/* 3b3 */	Trap, 0,
	/* 3b4 */	Trap, 0,
	/* 3b5 */	Trap, 0,
	/* 3b6 */	Trap, 0,
	/* 3b7 */	Trap, 0,
	/* 3b8 */	Trap, 0,
	/* 3b9 */	Trap, 0,
	/* 3ba */	Trap, 0,
	/* 3bb */	Trap, 0,
	/* 3bc */	Trap, 0,
	/* 3bd */	Trap, 0,
	/* 3be */	Trap, 0,
	/* 3bf */	Trap, 0,
	/* 3c0 */	Trap, 0,
	/* 3c1 */	Trap, 0,
	/* 3c2 */	Trap, 0,
	/* 3c3 */	Trap, 0,
	/* 3c4 */	Trap, 0,
	/* 3c5 */	Trap, 0,
	/* 3c6 */	Trap, 0,
	/* 3c7 */	Trap, 0,
	/* 3c8 */	Trap, 0,
	/* 3c9 */	Trap, 0,
	/* 3ca */	Trap, 0,
	/* 3cb */	Trap, 0,
	/* 3cc */	Trap, 0,
	/* 3cd */	Trap, 0,
	/* 3ce */	Trap, 0,
	/* 3cf */	Trap, 0,
	/* 3d0 */	Trap, 0,
	/* 3d1 */	Trap, 0,
	/* 3d2 */	Trap, 0,
	/* 3d3 */	Trap, 0,
	/* 3d4 */	Trap, 0,
	/* 3d5 */	Trap, 0,
	/* 3d6 */	Trap, 0,
	/* 3d7 */	Trap, 0,
	/* 3d8 */	Trap, 0,
	/* 3d9 */	Trap, 0,
	/* 3da */	Trap, 0,
	/* 3db */	Trap, 0,
	/* 3dc */	Trap, 0,
	/* 3dd */	Trap, 0,
	/* 3de */	Trap, 0,
	/* 3df */	Trap, 0,
	/* 3e0 */	Trap, 0,
	/* 3e1 */	Trap, 0,
	/* 3e2 */	Trap, 0,
	/* 3e3 */	Trap, 0,
	/* 3e4 */	Trap, 0,
	/* 3e5 */	Trap, 0,
	/* 3e6 */	Trap, 0,
	/* 3e7 */	Trap, 0,
	/* 3e8 */	Trap, 0,
	/* 3e9 */	Trap, 0,
	/* 3ea */	Trap, 0,
	/* 3eb */	Trap, 0,
	/* 3ec */	Trap, 0,
	/* 3ed */	Trap, 0,
	/* 3ee */	Trap, 0,
	/* 3ef */	Trap, 0,
	/* 3f0 */	Trap, 0,
	/* 3f1 */	Trap, 0,
	/* 3f2 */	Trap, 0,
	/* 3f3 */	Trap, 0,
	/* 3f4 */	Trap, 0,
	/* 3f5 */	Trap, 0,
	/* 3f6 */	Trap, 0,
	/* 3f7 */	Trap, 0,
	/* 3f8 */	Trap, 0,
	/* 3f9 */	Trap, 0,
	/* 3fa */	Trap, 0,
	/* 3fb */	Trap, 0,
	/* 3fc */	Trap, 0,
	/* 3fd */	Trap, 0,
	/* 3fe */	Trap, 0,
	/* 3ff */	Trap, 0,
	/* 400 */	Trap, 0,
	/* 401 */	Trap, 0,
	/* 402 */	Trap, 0,
	/* 403 */	Trap, 0,
	/* 404 */	Trap, 0,
	/* 405 */	Trap, 0,
	/* 406 */	Trap, 0,
	/* 407 */	Trap, 0,
	/* 408 */	Trap, 0,
	/* 409 */	Trap, 0,
	/* 40a */	Trap, 0,
	/* 40b */	Trap, 0,
	/* 40c */	Trap, 0,
	/* 40d */	Trap, 0,
	/* 40e */	Trap, 0,
	/* 40f */	Trap, 0,
	/* 410 */	Trap, 0,
	/* 411 */	Trap, 0,
	/* 412 */	Trap, 0,
	/* 413 */	Trap, 0,
	/* 414 */	Trap, 0,
	/* 415 */	Trap, 0,
	/* 416 */	Trap, 0,
	/* 417 */	Trap, 0,
	/* 418 */	Trap, 0,
	/* 419 */	Trap, 0,
	/* 41a */	Trap, 0,
	/* 41b */	Trap, 0,
	/* 41c */	Trap, 0,
	/* 41d */	Trap, 0,
	/* 41e */	Trap, 0,
	/* 41f */	Trap, 0,
	/* 420 */	Trap, 0,
	/* 421 */	Trap, 0,
	/* 422 */	Trap, 0,
	/* 423 */	Trap, 0,
	/* 424 */	Trap, 0,
	/* 425 */	Trap, 0,
	/* 426 */	Trap, 0,
	/* 427 */	Trap, 0,
	/* 428 */	Trap, 0,
	/* 429 */	Trap, 0,
	/* 42a */	Trap, 0,
	/* 42b */	Trap, 0,
	/* 42c */	Trap, 0,
	/* 42d */	Trap, 0,
	/* 42e */	Trap, 0,
	/* 42f */	Trap, 0,
	/* 430 */	Trap, 0,
	/* 431 */	Trap, 0,
	/* 432 */	Trap, 0,
	/* 433 */	Trap, 0,
	/* 434 */	Trap, 0,
	/* 435 */	Trap, 0,
	/* 436 */	Trap, 0,
	/* 437 */	Trap, 0,
	/* 438 */	Trap, 0,
	/* 439 */	Trap, 0,
	/* 43a */	Trap, 0,
	/* 43b */	Trap, 0,
	/* 43c */	Trap, 0,
	/* 43d */	Trap, 0,
	/* 43e */	Trap, 0,
	/* 43f */	Trap, 0,
	/* 440 */	Trap, 0,
	/* 441 */	Trap, 0,
	/* 442 */	Trap, 0,
	/* 443 */	Trap, 0,
	/* 444 */	Trap, 0,
	/* 445 */	Trap, 0,
	/* 446 */	Trap, 0,
	/* 447 */	Trap, 0,
	/* 448 */	Trap, 0,
	/* 449 */	Trap, 0,
	/* 44a */	Trap, 0,
	/* 44b */	Trap, 0,
	/* 44c */	Trap, 0,
	/* 44d */	Trap, 0,
	/* 44e */	Trap, 0,
	/* 44f */	Trap, 0,
	/* 450 */	Trap, 0,
	/* 451 */	Trap, 0,
	/* 452 */	Trap, 0,
	/* 453 */	Trap, 0,
	/* 454 */	Trap, 0,
	/* 455 */	Trap, 0,
	/* 456 */	Trap, 0,
	/* 457 */	Trap, 0,
	/* 458 */	Trap, 0,
	/* 459 */	Trap, 0,
	/* 45a */	Trap, 0,
	/* 45b */	Trap, 0,
	/* 45c */	Trap, 0,
	/* 45d */	Trap, 0,
	/* 45e */	Trap, 0,
	/* 45f */	Trap, 0,
	/* 460 */	Trap, 0,
	/* 461 */	Trap, 0,
	/* 462 */	Trap, 0,
	/* 463 */	Trap, 0,
	/* 464 */	Trap, 0,
	/* 465 */	Trap, 0,
	/* 466 */	Trap, 0,
	/* 467 */	Trap, 0,
	/* 468 */	Trap, 0,
	/* 469 */	Trap, 0,
	/* 46a */	Trap, 0,
	/* 46b */	Trap, 0,
	/* 46c */	Trap, 0,
	/* 46d */	Trap, 0,
	/* 46e */	Trap, 0,
	/* 46f */	Trap, 0,
	/* 470 */	Trap, 0,
	/* 471 */	Trap, 0,
	/* 472 */	Trap, 0,
	/* 473 */	Trap, 0,
	/* 474 */	Trap, 0,
	/* 475 */	Trap, 0,
	/* 476 */	Trap, 0,
	/* 477 */	Trap, 0,
	/* 478 */	Trap, 0,
	/* 479 */	Trap, 0,
	/* 47a */	Trap, 0,
	/* 47b */	Trap, 0,
	/* 47c */	Trap, 0,
	/* 47d */	Trap, 0,
	/* 47e */	Trap, 0,
	/* 47f */	Trap, 0,
	/* 480 */	Trap, 0,
	/* 481 */	Trap, 0,
	/* 482 */	Trap, 0,
	/* 483 */	Trap, 0,
	/* 484 */	Trap, 0,
	/* 485 */	Trap, 0,
	/* 486 */	Trap, 0,
	/* 487 */	Trap, 0,
	/* 488 */	Trap, 0,
	/* 489 */	Trap, 0,
	/* 48a */	Trap, 0,
	/* 48b */	Trap, 0,
	/* 48c */	Trap, 0,
	/* 48d */	Trap, 0,
	/* 48e */	Trap, 0,
	/* 48f */	Trap, 0,
	/* 490 */	Trap, 0,
	/* 491 */	Trap, 0,
	/* 492 */	Trap, 0,
	/* 493 */	Trap, 0,
	/* 494 */	Trap, 0,
	/* 495 */	Trap, 0,
	/* 496 */	Trap, 0,
	/* 497 */	Trap, 0,
	/* 498 */	Trap, 0,
	/* 499 */	Trap, 0,
	/* 49a */	Trap, 0,
	/* 49b */	Trap, 0,
	/* 49c */	Trap, 0,
	/* 49d */	Trap, 0,
	/* 49e */	Trap, 0,
	/* 49f */	Trap, 0,
	/* 4a0 */	Trap, 0,
	/* 4a1 */	Trap, 0,
	/* 4a2 */	Trap, 0,
	/* 4a3 */	Trap, 0,
	/* 4a4 */	Trap, 0,
	/* 4a5 */	Trap, 0,
	/* 4a6 */	Trap, 0,
	/* 4a7 */	Trap, 0,
	/* 4a8 */	Trap, 0,
	/* 4a9 */	Trap, 0,
	/* 4aa */	Trap, 0,
	/* 4ab */	Trap, 0,
	/* 4ac */	Trap, 0,
	/* 4ad */	Trap, 0,
	/* 4ae */	Trap, 0,
	/* 4af */	Trap, 0,
	/* 4b0 */	Trap, 0,
	/* 4b1 */	Trap, 0,
	/* 4b2 */	Trap, 0,
	/* 4b3 */	Trap, 0,
	/* 4b4 */	Trap, 0,
	/* 4b5 */	Trap, 0,
	/* 4b6 */	Trap, 0,
	/* 4b7 */	Trap, 0,
	/* 4b8 */	Trap, 0,
	/* 4b9 */	Trap, 0,
	/* 4ba */	Trap, 0,
	/* 4bb */	Trap, 0,
	/* 4bc */	Trap, 0,
	/* 4bd */	Trap, 0,
	/* 4be */	Trap, 0,
	/* 4bf */	Trap, 0,
	/* 4c0 */	Trap, 0,
	/* 4c1 */	Trap, 0,
	/* 4c2 */	Trap, 0,
	/* 4c3 */	Trap, 0,
	/* 4c4 */	Trap, 0,
	/* 4c5 */	Trap, 0,
	/* 4c6 */	Trap, 0,
	/* 4c7 */	Trap, 0,
	/* 4c8 */	Trap, 0,
	/* 4c9 */	Trap, 0,
	/* 4ca */	Trap, 0,
	0, 0
};
#endif

 /* Segment Table MMSYSTEM: */

SEGTAB SegmentTableMMSYSTEM[] =
{	{ (char *) seg_image_MMSYSTEM_0, 9808, TRANSFER_CALLBACK, 9808,0,0 },
	/* end */	{ 0, 0, 0, 0, 0, 0 }
};
