
#include "windows.h"
#include "Log.h"

static BOOL
DrawCaption(HDC hDC,LPRECT lprc,UINT uState)
{
	APISTR((LF_API,"DrawFrameControl[CAPTION](...)\n"));
	return TRUE;
}

static BOOL
DrawMenu(HDC hDC,LPRECT lprc,UINT uState)
{

	APISTR((LF_API,"DrawFrameControl[MENU](...)\n"));
	return TRUE;
}

static BOOL
DrawScroll(HDC hDC,LPRECT lprc,UINT uState)
{
	APISTR((LF_API,"DrawFrameControl[SCROLL](...)\n"));
	return TRUE;
}

static BOOL
DrawButton(HDC hDC,LPRECT lprc,UINT uState)
{
	HBRUSH hBrushFace;
	static int middle; /* BF_MIDDLE 0x800 */

	APISTR((LF_API,"DrawFrameControl[BUTTON](..,%d)\n",uState));
    	hBrushFace = GetSysColorBrush(COLOR_BTNFACE);
	FillRect(hDC,lprc,hBrushFace);

	if(uState & DFCS_PUSHED)
		DrawEdge(hDC,lprc,BDR_SUNKEN,BF_SOFT|BF_RECT|middle);
	else
		DrawEdge(hDC,lprc,BDR_RAISED,BF_SOFT|BF_RECT|middle);
	return TRUE;
}

BOOL
DrawFrameControl(HDC hDC,LPRECT lpRect,UINT uType,UINT uState)
{
	
	APISTR((LF_API,"DrawFrameControl(HDC=%x,LPRECT=%p[%d,%d,%d,%d],UINT=%x,UINT=%x)\n",
			hDC,lpRect,
			lpRect->left,lpRect->top,lpRect->right,lpRect->bottom,
			uType,uState));
	if (!hDC || !lpRect)
		return (FALSE);
	
	/* draw frame control */
	switch (uType) {
	case DFC_CAPTION:
		return DrawCaption(hDC, lpRect, uState);
	case DFC_MENU:
		return DrawMenu(hDC, lpRect, uState);
	case DFC_SCROLL:
		return DrawScroll(hDC, lpRect, uState);
	case DFC_BUTTON:
		return DrawButton(hDC, lpRect, uState);
	default:
		break;
	}

	/* exit */
	return (FALSE);
}
